{  This file is part of Reg_Lin_Mc, uncertainty calculation software
    Copyright (C) 2013  Jean-Marie Biansan
        Contact: jeanmarie.biansan@free.fr
    Web site: http://jeanmarie.biansan.free.fr/logiciel.html
 Reg_Lin_Mc is distribued under the terms of the
 GNU General Public License.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA}

unit UChaines;

{$mode objfpc}

interface

uses
  Classes, SysUtils; 

resourcestring
rsNonCalculabl = 'Non calculable';
rsegal = '=';
  rsGum_McLogici =
    'Gum_Mc, logiciel de le calcul de propagation d''incertitude';
  rsAProposDeCeL = 'A propos de ce logiciel...';
  rsGum_McEstLib = 'Gum_Mc est  libre et gratuit, sous license GPL.';
  rsVersion01Du1 = 'Version 1.50  du 11/12/2012, écrite en Lazarus';
  rsCopyrightJea = 'Copyright Jean-Marie Biansan,  2010, 2011, 2012';
  rsPourTouteRem = 'Pour toute remarque, cliquer sur:';
  rsVRifierQueVo =
    'Vérifier que vous avez la dernière version ? Cliquer sur:';
  rsSiteWebDeLAu = 'Site Web de l''auteur';

   rsSplashscreen = 'splashscreen';
  rsLogicielLibr = 'Logiciel libre et gratuit de calcul de propagation '
    +'d''incertitudes';
  rsVersion30Cod = 'Version 1.50  du 11/12/2012, écrite en Lazarus';
  rsParJeanMarie = 'Par Jean-Marie Biansan, 2010 à 2012';
  rsGummc = 'GUM_MC';
  rsSymbole = 'Symbole';
  rsClicIciPourD = 'Clic ici pour définir le mesurande !';
  rsCaractRistiq = 'Caractéristiques de la variable %s';
rsStudent = 'Student';
rsNormaleGauss = 'Normale(Gaussienne)';
rsRectangulair = 'Rectangulaire';
rsTriangulaire = 'Triangulaire';
rsTrapZoDale = 'Trapézoïdale';
rsDRivEDArcsin = 'Dérivée d''arcsinus';
rsClicIci = 'Clic ici';
rsIlNYAAucuneV = 'Il n''y a aucune variable !';
rsAttention = 'Attention';
rsIlYADesVaria = 'Il y a des variables non traitées !';
rsContribution = 'Contribution à la variance: (ci*u(xi))^2';
rsContribution2 = 'Contribution en % à la variance';
rsEstimateurDe = 'Estimateur de %s';
rsIncertitudeT = 'Incertitude-type uc(%s)';
rsTauxDeConfia = 'Taux de confiance';
rsFacteurDLarg = 'Facteur d''élargissement k';
rsIncertitudeL = 'Incertitude élargie U';
rsIntervalleYU = 'Intervalle [y-U ; y+U]';
rsEcritureFina = 'Ecriture finale (1 chiffre sur incertitude)';
rsEcritureFina2 = 'Ecriture finale (2 chiffres sur incertitude)';
rsFacteurDLarg2 = 'Facteur d''élargissement k';
rsFonctionDeDi = 'Fonction de distribution';
rsDensitDeProb = 'Densité de probabilité';
rsEstimateur = 'Estimateur';
rsEcartTypeCha = 'Ecart-type échantillonal';
rsIntervalle = 'Intervalle';
rsDemiLargeur = 'Demi-largeur';
rsValeursHorsL = 'Valeurs hors limites dans l''échantillon';
rsValeursHorsL2 = 'Valeurs hors limites dans l''échantillon';
rsValeurIllGal = 'Valeur illégale pour le taux !';
rsAttention2 = 'Attention !';
rsLeTauxDoitTr = 'Le taux doit être compris entre 0 et 100 !';
rsFacteurDLarg3 = 'Facteur d''élargissement k';
rsUnit = 'unité';
rsVousNAvezPas = 'Vous n''avez pas fourni d''expression !';
rsTypeEstimati = 'Type estimation';
rsIncertitudeT2 = 'Incertitude-type';
rsTypeDeDistri = 'Type de distribution';
rsTracDistribu = 'Tracé distribution';
rsTracDensit = 'Tracé densité';
rsClicIciPourD2 = 'Clic ici pour définir la grandeur';
rsClicIciPourM = 'Clic ici pour modifier la grandeur';
rsClicIciPourT = 'Clic ici pour tracer la distribution';
rsClicIciPourT2 = 'Clic ici pour tracer la densité';
rsErreurDeSynt = 'Erreur de syntaxe dans l''expression proposée !';
rsEvaluationDe = 'Evaluation de type A';
rsJePossDeNMes = 'Je possède N mesures répétées indépendantes de cette '
  +'grandeur.%sL''évaluation de l''incertitude-type sera faite par%sl'''
  +'analyse statistique de cette série d''observations.';
rsEvaluationDe2 = 'Evaluation de type B';
rsJePossDeUneS = 'Je possède une seule mesure de cette grandeur.%sL'''
  +'évaluation de l''incertitude-type sera faite par%sdes moyens autres que '
  +'l’analyse statistique de série d''observations:%s- spécifications '
  +'constructeur%s- certificats de calibration%s- connaissances par l'''
  +'expérience du comportement du matériel%s- incertitudes sur des données '
  +'extraites de bases de référence';
rs1erCas = '1er cas';
rs2ndCas = '2nd cas';
rsJAiDJCalculL = 'J''ai déjà calculé la moyenne%set l''écart-type '
  +'échantillonnal.%sJe vais les saisir.';
rsJeNAiPasCalc = 'Je n''ai pas calculé la moyenne%set l''écart-type '
  +'échantillonnal.%sJe vais  saisir mes mesures et le logiciel%sva les '
  +'calculer.';
rsEstUneValeur = '%s est une valeur numérique incorrecte!';
rsGum_MCLogici2 = 'Gum_MC: logiciel de calcul d''incertitudes composées';
rsBienvenue = 'Bienvenue';
rsBienvenueDan = 'Bienvenue dans GUM_MC';
rsLeButDeCeLog = 'Le but de ce logiciel est de faciliter le calcul des '
  +'incertitudes composées.';
rsIlTenteDeSui = 'Il tente de suivre les recommandations du BIPM données dans'
  +' les documents de référence du "GUM" (“Guide to the expression of '
  +'Uncertainty in Measurement”):';
rsLaDMarcheEst = 'La démarche est la suivante:%s1) Vous saisissez l'''
  +'expression de la grandeur (mesurande) Y dont on veut déterminer les '
  +'caractéristiques (grandeur "de sortie") en fonction des "grandeurs d'''
  +'entrée" mesurées, les Xi:%sY=f(X1,X2,...,XN)%s2) Vous saisissez les '
  +'caractéristiques des grandeurs d''entrée mesurées (mesurandes) Xi:%sa) '
  +'estimation xi%sb) incertitude type ("standard") u(xi)%sc) type de loi de '
  +'densité probabilité ("PDF")%s3) GUM_MC vous fournit l''estimation y de Y'
  +', son incertitude-type uc(Y) , les intervalles de confiance, et ce par '
  +'calcul de propagations des variances,%sen suivant le "GUM uncertainty '
  +'framework"%s4) Enfin, GUM_MC vous fournit une deuxième estimation de ces '
  +'quantités par simulation de Monte-Carlo ("MCM")%s( la procédure '
  +' adaptative n''est pas encore implémentée).';
rsRemarques1Le =
    'Remarques:%s1) les grandeurs d''entrée sont supposées '
  +'indépendantes (non corrélées).%s2) la virgule décimale est le point "."';
rsCliquezIciPo = 'Cliquez ici pour commencer>>>';
rsClicIciPourA = 'Clic ici pour aller chercher le fichier sur internet';
rsHttpWwwBipmO = 'http://www.bipm.org/utils/common/documents/jcgm/JCGM_100_200'
  +'8_E.pdf';
rsEtSonSupplMe = 'et son supplément sur la méthode de Monte-Carlo:';
rsHttpWwwBipmO2 = 'http://www.bipm.org/utils/common/documents/jcgm/JCGM_101_20'
  +'08_E.pdf';
rsExpressionDe = 'Expression de la grandeur de sortie';
rsValiderEtPas = 'Valider et passer aux grandeurs d''entrée>>>';
rsSaisissezIci = 'Saisissez ici l''expression en fonction des mesurandes d'''
  +'entrée';
rsSymboleGrand = 'Symbole grandeur de sortie';
rsY = 'Y';
rsSymboleGrand2 = 'Symbole grandeur de sortie:';
rsExpressionEn = 'Expression en fonction des mesurandes d''entrée:';
rs = '=';
rsCa = 'Ca';
rsCbVbVa = 'Cb*Vb/Va';
rsExemples = 'Exemples:';
rsR = 'R';
rsRmesuresrepe = 'Rmesuresrepetees+incertitude_resolution';
rsP = 'P';
rsRI2 = 'R*I^2';
rsSymboleUnit = 'Symbole unité';
rsSymboleDeLUn = 'Symbole de l''unité:';
rsGrandeursDEn = 'Grandeurs d''entrée';
rsValiderEtCal = 'Valider et calculer la grandeur de sortie >>>';
rsCliquezSurLa = 'Cliquez sur la ligne pour la modifier';
rsRSultatsParP = 'Résultats par propagation';
rsEstimations = 'Estimations';
rsGUMClassique = 'GUM "classique", ordre 1';
rsGUMClassique2 = 'GUM "classique", ordre 2';
rsTableauDesTe = 'Tableau des termes cij*(u(xi) u(xj))^2';
rsAccDerAuxInt = 'Accéder aux intervalles de confiance (modélisation normale'
  +') >>>';
rsIntervallesD = 'Intervalles de confiance: version 1';
rsIntervallesD2 = 'Intervalles de confiance, calcul approché en approximant '
  +'la distribution de sortie par une distribution normale:';
rsPourUnAutreT = 'Pour un autre taux de confiance, indiquez sa valeur et '
  +'cliquez sur "Calculer":';
rs2 = '%';
rsCalculer = 'Calculer';
rsAccDerAuxInt2 = 'Accéder aux intervalles de confiance (modélisation '
  +'Student)>>>';
rsIntervallesD3 = 'Intervalles de confiance: version 2';
rsIntervallesD4 = 'Intervalles de confiance, calcul approché en approximant '
  +'la distribution de sortie à une distribution de Student:';
rsDegrDeLibert = 'Degré de liberté effectif global:';
rsPourUnAutreT2 = 'Pour un autre taux de confiance, indiquez sa valeur et '
  +'cliquez sur "Calculer":';
rsAccDerAuxRSu = 'Accéder aux résultats de la méthode de Monte Carlo>>>';
rsRSultatsSimu = 'Résultats simulation de Monte Carlo';
rsEstimateurs = 'Estimateurs';
rsMThodeMonteC = 'Méthode Monte Carlo';
rsAccDerAuTrac = 'Accéder au tracé de la loi de distribution reconstituée '
  +'à partir de l''échantillon>>>';
rsAccDerAuTrac2 = 'Accéder au tracé de l''histogramme de la densité de '
  +'probabilité ("PFD")>>>';
rsHistogrammeD = 'Histogramme de densité';
rsAccDerAuxInt3 = 'Accéder aux intervalles de confiance issus de la MCM>>>';
rsIntervallesD5 = 'Intervalles de confiance';
rsIntervallesD6 = 'Intervalles de confiance symétriques (n''a d''intérêt '
  +'que si l''histogramme de densité est symétrique)';
rsIntervallesD7 = 'Intervalles de confiance les plus courts (n''a d''intérêt'
  +' que si l''histogramme de densité n''est pas symétrique)';
rsOptions = 'Options';
rsMonteCarlo = 'Monte-Carlo';
rsEnCasDIncert = 'En cas d''incertitude trop grande';
rsArrondiSurLI = 'Arrondi sur l''incertitude';
rsSupRieurDFau = 'Supérieur (défaut)';
rsNormal = 'Normal';
rsLangue = 'Langue';
rsAide = 'Aide';
rs3 = '-';
rsLicenceGPL = 'Licence GPL';
rsSiteWeb = 'Site Web';
rsAPropos = 'A propos';
rsSaisie_dune_ = 'saisie_dune_grandeur';
rsLoiDeDensitD = 'Loi de densité de probabilité ("PDF"):';
rsParamTresDeL = 'Paramètres de la loi:';
rsMoyenne = 'Moyenne:';
rsIncertitudeL2 = 'Incertitude élargie:';
rsAuTauxDe = 'Au taux de:';
rsEtAuChoix = 'Et au choix:';
rsDemiTendue = 'Demi-étendue:';
rsPanel2 = 'Panel2';
rsDemiTendueLa = 'Demi-étendue à la base:';
rsDemiTendueAu = 'Demi-étendue ausommet:';
rsIncertitudeT3 = 'Incertitude-type:';
rsValiderEtGNR = 'Valider et générer l''échantillon';
rsAnnuler = 'Annuler';
rsTypeA = 'Type A';
rsTypeB = 'Type B';
rsTypeDValuati = 'Type d''évaluation de l''incertitude-type:';
rsParamTreSupp = 'Paramètre supplémentaire:';
rsDansLeCasDUn =
    'Dans le cas d''une évaluation%sde l''incertitudede type B, '
  +'vous%spouvez éventuellement%sfournir en plus au choix:%s- l''incertitude '
  +'relative sur la%svaleur de l''incertitude%s- le degré de liberté effectif';
rsDegrDeLibert2 = 'Degré de liberté effectif';
rsIncRelativeS = 'Inc. relative sur l''incertitude';
rs0 = '0';
rsSiVousNEnSav = 'Si vous n''en savez rien,%slaissez l''incertitude relative%'
  +'ssur l''incertitude à 0.';
rsNombreDeDegr = 'Nombre de degré de liberté:';
rsEcartTypeCha2 = 'Ecart-type échantionnal s_N-1:';
rsEcartTypeDeL = 'Ecart-type de la moyenne:';
rsCEstLIncerti = '(c''est l''incertitude-type)';
rsNombreDeMesu = '(=nombre de mesures-1 si moyenne)';
rsPermetDeCalc = 'Permet de calculer moyenne et écart-type à partir des '
  +'mesures répétées';
rsSaisieDesNMe = 'Saisie des N mesures';
rsOuAlorsSaisi = 'Ou alors saisie directe de:';
rsAffichageEnC = 'Affichage en cas d''incertitude trop grande';
rsEnCasDIncert2 = 'En cas d''incertitude plus importante que le mesurande ('
  +'situation anormale):';
rsParExempleEs = 'Par exemple, estimateur 0.1 avec incertitude de 10:';
rsDonnera010 = 'donnera 0±10';
rsDonnera0110 = 'donnera 0.1±10';
rsIlFaudraReve = 'Il faudra revenir à l''onglet "Grandeurs d''entrée" et '
  +'valider pour que les modifications soient prises en compte.';
rsTypeDValuati2 = 'Type d''évaluation de l''incertitude';
rsOptionsSimul = 'Options simulation de Monte-Carlo';
rsPourChaqueGr = 'Pour chaque grandeur d''entrée, Reg_Lin_MC génére un '
  +'échantillon de M valeurs, extraites de la distribution saisie.';
rsPourDesRaiso = 'Pour des raisons pratiques, M est ici une puissance de 10: M'
  +'=10^n. Valeur recommandée n=6.';
rsN = 'n=';
rsGum_MCDTermi = 'Reg_Lin_MC détermine les M valeurs de l''échantillon de sortie'
  +'. Pour tracer un histogramme de la densité de sortie,';
rsIlDCoupeLCha = 'il "découpe" l''échantillon en p classes.';
rsP2 = 'p=';
rsValider = 'Valider.';
rsRemarqueSiVo = 'Remarque: si vous changez ces valeurs, il faut relancer la régression.';
rsPuisCeluiDeS = '';
rsArrondir0 = 'Arrondir à 0';
rsGarderUnChif = 'Garder un chiffre significatif';
rsLesSymbolesD = 'Les symboles des grandeurs d''entrée doivent commencer par '
  +'une lettre ou par _, et peuvent comporter lettres, chiffres, et le';
rsSymbole_ = 'symbole "_".';
rsExemplesXTot = 'Exemples: X, toto,alpha, r2p2, t6_po.';
rsLesFonctions = 'Les fonctions suivantes peuvent être utilisées:';
rsTrigonomTriq = '- trigonométriques: cos() sin() tan() cotan() arcsin() '
  +'arcos() arctan()';
rsDiversesSqrC = '- diverses: sqr() (carré)    sqrt() (racine carrée)';
rsExponentiell = '- exponentielles, logarithmiques et hyperboliques: exp() ln('
  +') log10() ou log()  log2() sinh() cosh() tanh() arcsinh() arcosh()';
rsArctanh = 'arctanh()';
rsHeavFonction = '- heav(), fonction de Heaviside: 1 si argument>0, 0 sinon';
rsTruncPartieE = '- trunc(): partie entière';
rsMinMaxArg = '- min(,), max(,), arg(,)';
rsLesOpRateurs = 'Les opérateurs disponibles   sont:             +  -   *   /'
  +'    ^.';
rsPiEstLaVaria = 'Pi est la variable prédéfinie Pi.';
rsNotationScie = 'Notation scientifique des nombres: -1.23e-6';
rsIlNYAPasDeDi = 'Il n''y a pas de distinction majuscule/minuscule.';
rsTrac = 'Tracé';
rsFermerLaFenT = 'Fermer la fenêtre';
rsEnRougeCourb = 'En rouge: courbe théorique';
rsEnBleuDAprSC = 'En bleu: d''après échantillon';
rsGum_MCLogici3 = 'Gum_MC, logiciel libre pour le calcul de propagation d'''
  +'incertitude';
rsVersion101Du = 'Version 1.50 du 11/12/2012';
rsContribution3 = 'Contribution à la variance en %';
rsCopyrightJea2 = 'Copyright Jean-Marie Biansan, 2010, 2011, 2012';
rsGum_MCUnLogi = 'Reg_Lin_MC un logiciel libre, diffusé sous licence GNU GPL.';
rsUneCopieDeLa = 'Une copie de la licence est fournie avec le logiciel.';
rsAuxTermesDeL = 'Aux termes de la licence, vous pouvez librement utiliser et '
  +'copier';
rsGum_MCEtLeDi = 'Reg_Lin_MC, et le diffuser en respectant les termes de la '
  +'licence.';
rsVousPouvezME = 'Vous pouvez m''envoyer un courriel pour toute remarque, '
  +'compte-rendu de bug,';
rsPropositionD = 'proposition d''amélioration:   jeanmarie.biansan@free.fr.';
rsAideAuCalcul = 'Aide au calcul';
rsDansLeCasDeN = 'Dans le cas de N mesures répétées, cette page permet le '
  +'calcul de la moyenne';
rsStaticText_m = 'StaticText_moyenne';
rsEcartTypeCha3 = 'Ecart-type échantillonnal:';
rsValiderEtRep = 'Valider et reporter les valeurs';
rsEtDeLCartTyp = 'et de l''écart-type échantillonnal:';
rsNombreDeVale = 'Nombre de valeurs correctes:';
rsSupprimerLig = 'Supprimer ligne courante';
rsMesures = 'Mesures';
rsCopierDansLe = 'Copier dans le presse-papier';
rsCopierLeGrap = 'Copier le graphe dans le presse-papier';
rsNormale = 'Normale';
rsTrapezoDale = 'Trapezoïdale';
rsDRivEDArcsin2 = 'Dérivée d''arcsinus';
rsDuRPertoireE = 'Du répertoire "exemples"';
rsDeMonRPertoi = 'De mon répertoire personnel';
rsOuvrir = 'Ouvrir';
rsFichier = 'Fichier';
rsImpossibleDe = 'Impossible de charger %s';
rsHLas = 'Hélas...';
rsNom_variable = 'nom_variable attendu et non trouvé dans le fichier';
rsAttention3 = 'Attention...';
rsVariableTrou = 'variable%s trouvée dans le fichier et pas reconnue';
rsType_ABAtten = 'type_AB attendu et non trouvé dans le fichier !';
rsType_distrib = 'type_distribution attendu et non trouvé dans le fichier !';
rsDefini_parAt = 'defini_par attendu et non trouvé dans le fichier !';
rsParametresAt = 'parametres attendu et non trouvé dans le fichier !';
rsValeurDeLaMo = 'Valeur de la moyenne illégale.';
rsValeurDuNomb = 'Valeur du nombre de degré de liberté illégale.';
rsValeurDeLCar = 'Valeur de l''écart-type illégale.';
rsValeurDeLCar2 = 'Valeur de l''écart-type illégale.';
rsValeurDeLCar3 = 'Valeur de l''écart-type illégale.';
rsValeurDeLCar4 = 'Valeur de l''écart-type illégale.';
rsValeurDeLInc = 'Valeur de l''incertitude illégale.';
rsValeurDeLInc2 = 'Valeur de l''incertitude-type illégale.';
rsValeurDuPour = 'Valeur du pourcentage illégale.';
rsValeurDeLInc3 = 'Valeur de l''incertitude relative sur l''incertitude '
  +'illégale.';
rsValeurDeLInc4 = 'Valeur de l''incertitude relative sur l''incertitude '
  +'toujours <=100% ! ';
rsValeurDuDegr = 'Valeur du degré de liberté effectif illégale.';
rsValeurDuDegr2 = 'Valeur du degré de liberté effectif toujours >1/2 ! ';
rsValeurDeLInc5 = 'Valeur de l''incertitude-type illégale.';
rsValeurDeLInc6 = 'Valeur de l''incertitude-type illégale.';
rsValeurDeLInc7 = 'Valeur de l''incertitude illégale.';
rsValeurDeLInc8 = 'Valeur de l''incertitude-type illégale.';
rsValeurDeLInc9 = 'Valeur de l''incertitude-type illégale.';
rsValeurDeLInc10 = 'Valeur de l''incertitude-type illégale.';
rsValeurDeLaDe = 'Valeur de la demi-étendue illégale.';
rsValeurDeLInc11 = 'Valeur de l''incertitude-type illégale.';
rsValeurDeLInc12 = 'Valeur de l''incertitude-type illégale.';
rsValeurDeLInc13 = 'Valeur de l''incertitude-type illégale.';
rsValeurDeLInc14 = 'Valeur de l''incertitude-type illégale.';
rsValeurDeLInc15 = 'Valeur de l''incertitude-type illégale.';
rsValeurDeLInc16 = 'Valeur de l''incertitude-type illégale.';
rsDemiTendueHa = 'Demi-étendue haut doit être < demi-étendue basse.';
rsValeurDeLInc17 = 'Valeur de l''incertitude-type illégale.';
rsMoyenneAtten = 'moyenne attendue et non trouvé dans le fichier !';
rsIncertitude_ = 'incertitude_type attendue et non trouvé dans le fichier !';
rsDemi_etendue = 'demi_etendue attendue et non trouvé dans le fichier !';
rsIncertitude_2 = 'incertitude_elargie attendue et non trouvé dans le fichier'
  +' !';
rsPourcentageA = 'pourcentage attendue et non trouvé dans le fichier !';
rsEcart_type_e = 'ecart_type_echantionnal attendue et non trouvé dans le '
  +'fichier !';
rsDemi_etendue2 = 'demi_etendue_bas attendue et non trouvé dans le fichier !';
rsDemi_etendue3 = 'demi_etendue_haut attendue et non trouvé dans le fichier !';
rsDegres_de_li = 'degres_de_liberte attendue et non trouvé dans le fichier !';
rsInc_rel_sur_ = 'inc_rel_sur_inc attendue et non trouvé dans le fichier !';
rsDegres_de_li2 = 'degres_de_liberte_effectif attendue et non trouvé dans le '
  +'fichier !';
rsStudent_nomb = 'student_nombre_mesures attendu et non trouvé dans le '
  +'fichier !';
rsCommentaires = 'commentaires attendu et non trouvé dans le fichier !';
rsNombre_ligne = 'nombre_lignes_commentaires attendu et non trouvé dans le '
  +'fichier !';
rsNouveau = 'Nouveau';
rsEnregistrer = 'Enregistrer';
rsDuRPertoireP = 'Du répertoire personnel';
rsIlFautAvoirE = 'Il faut avoir effectué un calcul de propagation avan de '
  +'sauver !';
rsCommentaires2 = 'Commentaires';
rsDuDernierRPe = 'Du dernier répertoire autre utilisé en ouverture';
rsDansLeRPerto = 'Dans le répertoire personnel';
rsDansLeDernie = 'Dans le dernier répertoire autre utilisé en sauvegarde';
rsDansLeRPerto2 = 'Dans le répertoire "exemples" (si droit d''écriture)';
rsEnregistrerS = 'Enregistrer sous';
rsLeFichierExi = 'Le fichier %s existe déjà. Voulez-vous l''écraser ?';
rsLeFichierExi2 = 'Le fichier %s existe déjà. Voulez-vous l''écraser ?';
rsLeFichierExi3 = 'Le fichier %s existe déjà. Voulez-vous l''écraser ?';
rsIncertitudeT4 = 'Incertitude-type relative uc(%s)/%s';
rsAccDerAuxRSu2 = 'Accéder aux résultats du GUM à l''ordre 2';
rsDiagramme = 'Diagramme';
rsBarres = 'Barres';
rsCamembert = 'Camembert';
rsDescriptif = 'Descriptif';
rsVousPouvezSa = 'Vous pouvez saisir un descriptif pour ce mesurande:';
rsMesurande = 'Mesurande %s';
rsCliquezIciPo2 = 'Cliquez ici pour saisir ou modifier le descriptif de %s';
rsCliquezIciPo3 = 'Cliquez ici pour saisir ou modifier le descriptif de ';
rsChargementFi = 'Chargement fichier expérience';
 rsVoiciLes4Pre = 'Voici les 4 premières lignes du fichier:';
 rsVeuillezComp = 'Veuillez compléter les informations suivantes:';
 rsLigneLaquell = 'Ligne à laquelle commencent les données:';
 rsNombreDeDonn = 'Nombre de données par ligne:';
 rsColonneDontL = 'Colonne dont la grandeur sera considérée comme abscisse:';
 rsValeursNumRi = 'Valeurs numériques séparées par:';
 rsUnOuPlusieur = 'Un ou plusieurs espaces';
 rsRecalculerAu = 'Recalculer automatiquement les échelles verticales';
 rsTypeDeLaDonn = 'Type de la donnée de la colonne %s';
 rsPointVirgule = 'Point virgule';
 rsLeFichierCon = 'Le fichier contient moins de lignes que la ligne que vous '
   +'avez indiqué comme étant la première que contient des données !';
 rsOK = '&OK';
  rsFichierImpos = 'Fichier impossible à ouvrir';
  rsPasDeDonnEsS = 'Pas de données sur la ligne spécifiée';
  rsSParateurSpC = 'Séparateur spécifié introuvable à  la ligne %s';
  rsFormatValeur = 'Format valeur numérique incorrect à  la ligne %s';
  rsFichierCorro = 'Fichier corrompu...';

   rsHLas2 = 'Hélas';
   rsIlFautAuMoin = 'Il faut au moins 2 colonnes: x, y.';
   rsIlFautAuMoin2 =
     'Il faut au moins 4 points pour réaliser la régression !';
   rsReg_Lin_MCLo = 'Reg_Lin_MC,logiciel libre de régression linéaire';
   rsVersion10Du2 = 'Version 1.1 du 25/01/2014';
   rsCopyrightJea3 = 'Copyright Jean-Marie Biansan, 2013, 2014';
   rsReg_Lin_MC = 'Reg_Lin_MC';
   rsLogicielLibr2 = 'Logiciel libre et gratuit de régression linéaire';
   rsVersion101Du2 = 'Version 1.1 du 25/01/2014 écrite en Lazarus';
   rsParJeanMarie2 = 'Par Jean-Marie Biansan, 2013, 2014';

     rsCsv = '.csv';
  rsTableurTexte2 = 'Tableur texte (*.csv;*.txt)|*.csv;*.txt';



implementation

end.

