{  This file is part of Reg_Lin_Mc, uncertainty calculation software
    Copyright (C) 2013  Jean-Marie Biansan
        Contact: jeanmarie.biansan@free.fr
    Web site: http://jeanmarie.biansan.free.fr/logiciel.html
    Reg_Lin_Mc is distribued under the terms of the
 GNU General Public License.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA}



unit Unit_genere_distribution;

{$mode objfpc}

interface

uses
 Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons,LCLType,ISAAC,Math,SpecFunx,Amath;

type
    extendedarray=array of extended;
    extendedarray2D=array of  array of extended;
   longintarray=array of longint;
   longintarray2D=array  of array of longint;
   type_affichage_incertitude=(sans_point_decimal,sans_puissance_de_dix,avec_un_chiffre_avant_virgule_pour_valeur,avec_un_chiffre_avant_virgule_pour_incertitude);
    type_affichage_valeur_individuelle=(_sans_point_decimal,_sans_puissance_de_dix,_avec_un_chiffre_avant_virgule);
   TExtRec  = packed record     {Extended as sign, exponent, significand}
               lm: longint;    {low  32 bit of significand}
               hm: longint;    {high 32 bit of significand}
               xp: word;       {biased exponent and sign  }
             end;


  var  rng: isaac_ctx;

 Procedure Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(const x:extended; const nombre_chiffres_significatifs:integer; puissance_de_dix_souhaitee:integer;
var puissance_de_dix_pour_ne_pas_avoir_de_virgule:integer; arrondi_superieur:boolean; var mantisse,exposant:string);
  Function Donne_Avec_Chiffres_Significatifs(const x:extended; const nombre_chiffres_significatifs:integer;
  genre_affichage_valeur_individuelle:type_affichage_valeur_individuelle; longueur_chaine_agreable:integer):string;
 Function Donne_Avec_Chiffres_Significatifs2(const x:extended; const nombre_chiffres_significatifs:integer;  puissance_de_dix_souhaitee:integer;
var puissance_de_dix_pour_ne_pas_avoir_de_virgule:integer; arrondi_superieur:boolean):string;
  Function Donne_Avec_Chiffres_Significatifs_Arrondi_Superieur(const x:extended; const nombre_chiffres_significatifs:integer;
  genre_affichage_valeur_individuelle:type_affichage_valeur_individuelle; longueur_chaine_agreable:integer):string;
  Function Donne_Selon_Incertitude(const x,incertitude:extended; nombre_de_chiffres_incertitude:integer;
  option_tronque_a_zero_quand_incertitude_trop_grande:boolean; arrondi_superieur_sur_incertitude:boolean;
  genre_affichage_incertitude:type_affichage_incertitude; longueur_chaine_agreable:integer):string;
  Function Donne_Selon_Incertitude_Sans_Incertitude(const x,incertitude:extended; nombre_de_chiffres_incertitude:integer;
  option_tronque_a_zero_quand_incertitude_trop_grande:boolean; arrondi_superieur_sur_incertitude:boolean;
  genre_affichage_incertitude:type_affichage_incertitude; longueur_chaine_agreable:integer):string;
  Procedure Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(const x:extended; const puissance_de_dix_souhaitee:integer;
 arrondi_superieur:boolean; var mantisse,exposant:string);
  Function Puissance_Du_Dernier_Chiffre_Significatif(const s:string):integer;
  Function Rajoute_Zero_Significatif(const s:string):string;
  procedure decale_virgule_vers_la_gauche(var mantisse:string);

  procedure Copie_Distribution(const source:extendedarray; var destination:extendedarray; const nombre:longint);
  procedure Initialise_Generateur(seed:longint);

procedure Genere_Uniforme_Dans01(var res:extendedarray;const nombre:longint);

procedure Genere_Normale(var res:extendedarray;const  nombre:longint;const  moyenne,ecart_type:extended);
procedure Genere_BiNormale(var res1,res2:extendedarray; const nombre:longint; const moyenne1,ecart_type1,moyenne2,ecart_type2,coef_correlation:extended);
procedure Genere_Gamma(var res:extendedarray;const  nombre:longint;const  alpha,beta:extended);

procedure Genere_Student(var res:extendedarray;const  nombre:longint;const  moyenne,ecart_type:extended;const degre_de_liberte:longint);

procedure Genere_Triangulaire(var res:extendedarray; const nombre:longint; const moyenne,demi_etendue:extended);

procedure Genere_Rectangulaire(var res:extendedarray; const nombre:longint; const moyenne,demi_etendue:extended);

procedure Genere_Derivee_D_Arcsinus(var res:extendedarray; const nombre:longint; const moyenne,demi_etendue:extended);

procedure Genere_Trapeze(var res:extendedarray; const nombre:longint; const moyenne,demi_etendue_bas,demi_etendue_haut:extended);

function Calcule_Moyenne_Et_Ecart_Type(const donnees:extendedarray; const nombre:longint; var moyenne,ecart_type,skewness,kurtosis:extended):boolean;
function Calcule_Covariance(const donnees1,donnees2:extendedarray; const nombre:longint; var covariance:extended):boolean;
function Statistiques_Par_Classe(const donnees:extendedarray; const nombre:longint; const nombre_classes:longint; var bornes:extendedarray;
var effectifs:longintarray; var densites:extendedarray ;var effectif_max:longint; var densite_max:extended):boolean;

function Statistiques_Par_Classe_2D(const donnees_x,donnees_y:extendedarray; const nombre:longint; const nombre_classes_x,nombre_classes_y:longint;
var bornes_x,bornes_y:extendedarray;
var effectifs:longintarray2D; var densites:extendedarray2D ;var effectif_max:longint; var densite_max:extended):boolean;


procedure Tri_Rapide(VAR arr: extendedarray; const size:longint);

procedure Decale_Doublons(VAR arr: extendedarray; const nombre:longint);

procedure Intervalle_Recouvrement_Le_Plus_Court(const pourcentage:extended; const donnees:extendedarray;
const nombre:longint; var borne_inf,borne_sup:extended);

procedure Intervalle_Recouvrement_Symetrique(const pourcentage:extended; const donnees:extendedarray;
const nombre:longint; var borne_inf,borne_sup:extended);
procedure Intervalle_Recouvrement_Symetrique_Par_Rapport_A_La_Moyenne(const pourcentage:extended; const donnees:extendedarray;
const nombre:longint; const moyenne:extended; var borne_inf,borne_sup:extended);

function Student_Integree(const moyenne,ecart_type:extended; const degres_de_liberte:longint; const x:extended):extended;
function Student_Densite(const moyenne,ecart_type:extended; const degres_de_liberte:longint;const  x:extended):extended;
function Uniforme_Integree(const x:extended):extended;
function Uniforme_Densite(const  x:extended):extended;
function Rectangulaire_Densite(const moyenne,demi_etendue,x:extended):extended;
function Rectangulaire_Integree(const moyenne,demi_etendue,x:extended):extended;
function Trapeze_Densite(const moyenne,demi_etendue_bas,demi_etendue_haut,x:extended):extended;
function Trapeze_Integree(const moyenne,demi_etendue_bas,demi_etendue_haut,x:extended):extended;
function Triangulaire_Densite(const moyenne,demi_etendue,x:extended):extended;
function Triangulaire_Integree(const moyenne,demi_etendue,x:extended):extended;
function Derivee_D_Arcsinus_Densite(const moyenne,demi_etendue,x:extended):extended;
function Derivee_D_Arcsinus_Integree(const moyenne,demi_etendue,x:extended):extended;
function Normale_Integree(const moyenne,ecart_type:extended; const x:extended):extended;
function Normale_Densite(const moyenne,ecart_type:extended; const  x:extended):extended;
function Fonction_Distribution(const donnees:extendedarray; const nombre:longint; const x:extended):extended;
function EgaliteReels(n1,n2 : extended) : boolean;
implementation

function MyIsnan(x: float): boolean;
 {-Return true if x is a NaN}
begin
 with TExtRec(x) do begin
   MyIsnan := (xp and $7FFF=$7FFF) and ((hm<>longint($80000000)) or (lm<>0));
 end;
end;

function isnanorinfinite(x:float):boolean;
begin
result:=(myisnan(x) or isinfinite(x));
end;


Function Donne_Selon_Incertitude_Sans_Incertitude(const x,incertitude:extended; nombre_de_chiffres_incertitude:integer;
option_tronque_a_zero_quand_incertitude_trop_grande:boolean; arrondi_superieur_sur_incertitude:boolean;
genre_affichage_incertitude:type_affichage_incertitude; longueur_chaine_agreable:integer):string;
var s1,s2:string; positif:boolean; r,incer,dix_test:extended; i,p1,n1,n2,puissance_sans_virgule_incertitude,puissance_sans_virgule_valeur,lma2:integer;
                   mantisse1,mantisse2,exposant1,exposant2:string;
begin

if isnanorinf(x) then begin
Donne_Selon_Incertitude_Sans_Incertitude:='NAN';
exit;
end;

if isnanorinf(incertitude) then begin
Donne_Selon_Incertitude_Sans_Incertitude:='NAN';
exit;
end;

positif:=(x>0);
r:=abs(x); incer:=abs(incertitude);
if (incer=0) then begin
Donne_Selon_Incertitude_Sans_Incertitude:='Impossible';
exit;
end;


 Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
 s1:=Donne_Avec_Chiffres_Significatifs2(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,arrondi_superieur_sur_incertitude);


p1:=floor(ln(strtofloat(s1))/ln(10)); {puissance de 10 de l'incertitude}
//n1:=p1-nombre_de_chiffres_incertitude+1;  {puissance de 10 du dernier chiffre de l'incertitude}
n1:=Puissance_Du_Dernier_Chiffre_Significatif(s1);

if r=0 then begin

if n1>=0 then s2:='0' else
begin
s2:='0.';
for i:=1 to -n1 do s2:=s2+'0';
Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,0,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
 s1:=Donne_Avec_Chiffres_Significatifs2(abs(incertitude),nombre_de_chiffres_incertitude,0,puissance_sans_virgule_incertitude,arrondi_superieur_sur_incertitude);
end;
mantisse2:=s2; exposant2:='';
Donne_Selon_Incertitude_Sans_Incertitude:=mantisse2+exposant1;
exit;
end;



n2:=floor(ln(r)/ln(10));   {puissance de 10 de la valeur}
dix_test:=1;
if n2>0 then for i:=1 to n2 do dix_test:=dix_test*10;
if n2<0 then for i:=1 to -n2 do dix_test:=dix_test/10;
dix_test:=dix_test*10;
 if EgaliteReels(r,dix_test) then n2:=n2+1;


if n2-n1+1<1 then begin
if option_tronque_a_zero_quand_incertitude_trop_grande then
begin s2:='0';mantisse2:=s2; exposant2:=''; end  else
begin
s2:=Donne_Avec_Chiffres_Significatifs2(x,1,-1000,puissance_sans_virgule_valeur,false);
Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(x,1,-1000,puissance_sans_virgule_valeur,false,mantisse2,exposant2);
end;
Donne_Selon_Incertitude_Sans_Incertitude:=mantisse2+exposant1;
exit;
end;

   if genre_affichage_incertitude=sans_point_decimal then begin
   Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(x,n1,false,mantisse2,exposant2);
 Donne_Selon_Incertitude_Sans_Incertitude:=mantisse2+exposant1;
  exit;
 end;




   if genre_affichage_incertitude=sans_puissance_de_dix then begin
   Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(r,n1,false,mantisse2,exposant2);
   if (exposant1='') or (exposant1='E') then puissance_sans_virgule_incertitude:=0 else
   puissance_sans_virgule_incertitude:=strtoint(copy(exposant1,2,length(exposant1)-1));
   if puissance_sans_virgule_incertitude=0 then  exposant1:='';
   if puissance_sans_virgule_incertitude>=0   then begin
    if not(positif) then mantisse2:='-'+mantisse2;

     if length(mantisse2+exposant1)<=longueur_chaine_agreable then
    Donne_Selon_Incertitude_Sans_Incertitude:=mantisse2+exposant1 else
    begin
     Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(x,n1,false,mantisse2,exposant2);
 Donne_Selon_Incertitude_Sans_Incertitude:=mantisse2+exposant1;
   end;

  exit;
   end;


    if  -puissance_sans_virgule_incertitude< length(mantisse2)-1 then insert('.',mantisse2,length(mantisse2)-(-puissance_sans_virgule_incertitude)+1)
     else  begin
   for i:=1 to -puissance_sans_virgule_incertitude+1-length(mantisse2)do mantisse2:='0'+mantisse2;
   insert('.', mantisse2,2);
     end;

  if  -puissance_sans_virgule_incertitude< length(mantisse1)-1 then insert('.',mantisse1,length(mantisse1)-(-puissance_sans_virgule_incertitude)+1)
     else  begin
   for i:=1 to -puissance_sans_virgule_incertitude+1-length(mantisse1)do mantisse1:='0'+mantisse1;
   insert('.', mantisse1,2);
     end;

   if not(positif) then mantisse2:='-'+mantisse2;


     if length(mantisse2)<=longueur_chaine_agreable then
    Donne_Selon_Incertitude_Sans_Incertitude:=mantisse2 else
    begin
     Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(x,n1,false,mantisse2,exposant2);
 Donne_Selon_Incertitude_Sans_Incertitude:=mantisse2+exposant1;
   end;

 exit;
 end;




    if genre_affichage_incertitude=avec_un_chiffre_avant_virgule_pour_incertitude then begin

 Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
     arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   if (exposant1='') or (exposant1='E') then puissance_sans_virgule_incertitude:=0 else
   puissance_sans_virgule_incertitude:=strtoint(copy(exposant1,2,length(exposant1)-1));
    Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(r,puissance_sans_virgule_incertitude,false,mantisse2,exposant2);

    if  nombre_de_chiffres_incertitude>1 then
    if  nombre_de_chiffres_incertitude-1< length(mantisse2)-1 then insert('.',mantisse2,length(mantisse2)-(nombre_de_chiffres_incertitude-1)+1)
     else  begin
   for i:=1 to nombre_de_chiffres_incertitude-length(mantisse2)do mantisse2:='0'+mantisse2;
   insert('.', mantisse2,2);
     end;

     if  nombre_de_chiffres_incertitude>1 then
        insert('.', mantisse1,2);


     exposant1:='E'+inttostr(puissance_sans_virgule_incertitude+nombre_de_chiffres_incertitude-1);
     if not(positif) then mantisse2:='-'+mantisse2;
     if puissance_sans_virgule_incertitude=0 then exposant1:='';

    if length(mantisse2+exposant1)<=longueur_chaine_agreable then
    Donne_Selon_Incertitude_Sans_Incertitude:=mantisse2+exposant1 else
    begin
     Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(x,n1,false,mantisse2,exposant2);
 Donne_Selon_Incertitude_Sans_Incertitude:=mantisse2+exposant1;
   end;
     exit;
     end;












  if genre_affichage_incertitude=avec_un_chiffre_avant_virgule_pour_valeur then begin

   Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
     arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   if (exposant1='') or (exposant1='E') then puissance_sans_virgule_incertitude:=0 else
   puissance_sans_virgule_incertitude:=strtoint(copy(exposant1,2,length(exposant1)-1));
    Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(r,puissance_sans_virgule_incertitude,false,mantisse2,exposant2);
      lma2:=length(mantisse2);
     if  lma2>1 then
        insert('.', mantisse2,2);


    if  lma2>1 then
    if  lma2-1< length(mantisse1)-1 then insert('.',mantisse1,length(mantisse1)-(lma2-1)+1)
     else  begin
   for i:=1 to lma2-length(mantisse1)do mantisse1:='0'+mantisse1;
   insert('.', mantisse1,2);
     end;


           puissance_sans_virgule_incertitude:=puissance_sans_virgule_incertitude+lma2-1;
     exposant1:='E'+inttostr(puissance_sans_virgule_incertitude);
     if not(positif) then mantisse2:='-'+mantisse2;
     if puissance_sans_virgule_incertitude=0 then exposant1:='';

    if length(mantisse2+exposant1)<=longueur_chaine_agreable then
    Donne_Selon_Incertitude_Sans_Incertitude:=mantisse2+exposant1 else
    begin
     Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(x,n1,false,mantisse2,exposant2);
 Donne_Selon_Incertitude_Sans_Incertitude:=mantisse2+exposant1;
   end;
     exit;
     end;

  end;



procedure decale_virgule_vers_la_gauche(var mantisse:string);
var i:integer;
begin
i:=pos('.',mantisse);

if i=0 then begin
insert('.',mantisse,length(mantisse));
exit;
end;

if i>2 then begin
delete(mantisse,i,1);
insert('.',mantisse,i-1);
exit;
end;

if (i=2) and (mantisse[1]<>'0') then begin
delete(mantisse,i,1);
insert('0.',mantisse,1);
exit;
end;

if (i=2) and (mantisse[1]='0') then begin
insert('0',mantisse,3);
exit;
end;

end;




Function Donne_Selon_Incertitude(const x,incertitude:extended; nombre_de_chiffres_incertitude:integer;
option_tronque_a_zero_quand_incertitude_trop_grande:boolean; arrondi_superieur_sur_incertitude:boolean;
genre_affichage_incertitude:type_affichage_incertitude; longueur_chaine_agreable:integer):string;
var s1,s2:string; positif:boolean; r,incer,dix_test:extended; i,p1,n1,n2,puissance_sans_virgule_incertitude,puissance_sans_virgule_valeur,lma2:integer;
                   mantisse1,mantisse2,exposant1,exposant2:string;
begin

if isnanorinf(x) then begin
Donne_Selon_Incertitude:='NAN';
exit;
end;

if isnanorinf(incertitude) then begin
Donne_Selon_Incertitude:='NAN';
exit;
end;

positif:=(x>0);
r:=abs(x); incer:=abs(incertitude);
if (incer=0) then begin
Donne_Selon_Incertitude:='Impossible';
exit;
end;


 Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
 s1:=Donne_Avec_Chiffres_Significatifs2(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,arrondi_superieur_sur_incertitude);


p1:=floor(ln(strtofloat(s1))/ln(10)); {puissance de 10 de l'incertitude}
//n1:=p1-nombre_de_chiffres_incertitude+1;  {puissance de 10 du dernier chiffre de l'incertitude}
n1:=Puissance_Du_Dernier_Chiffre_Significatif(s1);

if r=0 then begin

if n1>=0 then s2:='0' else
begin
s2:='0.';
for i:=1 to -n1 do s2:=s2+'0';
Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,0,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
 s1:=Donne_Avec_Chiffres_Significatifs2(abs(incertitude),nombre_de_chiffres_incertitude,0,puissance_sans_virgule_incertitude,arrondi_superieur_sur_incertitude);
end;
mantisse2:=s2; exposant2:='';
Donne_Selon_Incertitude:='('+mantisse2+'±'+mantisse1+')'+exposant1;
exit;
end;



n2:=floor(ln(r)/ln(10));   {puissance de 10 de la valeur}
dix_test:=1;
if n2>0 then for i:=1 to n2 do dix_test:=dix_test*10;
if n2<0 then for i:=1 to -n2 do dix_test:=dix_test/10;
dix_test:=dix_test*10;
 if EgaliteReels(r,dix_test) then n2:=n2+1;


if n2-n1+1<1 then begin
if option_tronque_a_zero_quand_incertitude_trop_grande then
begin s2:='0';mantisse2:=s2; exposant2:=''; end  else
begin
s2:=Donne_Avec_Chiffres_Significatifs2(x,1,-1000,puissance_sans_virgule_valeur,false);
Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(x,1,-1000,puissance_sans_virgule_valeur,false,mantisse2,exposant2);
end;
Donne_Selon_Incertitude:='('+mantisse2+'±'+mantisse1+')'+exposant1;
exit;
end;

   if genre_affichage_incertitude=sans_point_decimal then begin
   Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(x,n1,false,mantisse2,exposant2);
 Donne_Selon_Incertitude:='('+mantisse2+'±'+mantisse1+')'+exposant1;
  exit;
 end;




   if genre_affichage_incertitude=sans_puissance_de_dix then begin
   Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(r,n1,false,mantisse2,exposant2);
   if (exposant1='') or (exposant1='E') then puissance_sans_virgule_incertitude:=0 else
   puissance_sans_virgule_incertitude:=strtoint(copy(exposant1,2,length(exposant1)-1));
   if puissance_sans_virgule_incertitude=0 then  exposant1:='';
   if puissance_sans_virgule_incertitude>=0   then begin
    if not(positif) then mantisse2:='-'+mantisse2;

     if length('('+mantisse2+'±'+mantisse1+')'+exposant1)<=longueur_chaine_agreable then
    Donne_Selon_Incertitude:='('+mantisse2+'±'+mantisse1+')'+exposant1 else
    begin
     Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(x,n1,false,mantisse2,exposant2);
 Donne_Selon_Incertitude:='('+mantisse2+'±'+mantisse1+')'+exposant1;
   end;

  exit;
   end;


    if  -puissance_sans_virgule_incertitude< length(mantisse2)-1 then insert('.',mantisse2,length(mantisse2)-(-puissance_sans_virgule_incertitude)+1)
     else  begin
   for i:=1 to -puissance_sans_virgule_incertitude+1-length(mantisse2)do mantisse2:='0'+mantisse2;
   insert('.', mantisse2,2);
     end;

  if  -puissance_sans_virgule_incertitude< length(mantisse1)-1 then insert('.',mantisse1,length(mantisse1)-(-puissance_sans_virgule_incertitude)+1)
     else  begin
   for i:=1 to -puissance_sans_virgule_incertitude+1-length(mantisse1)do mantisse1:='0'+mantisse1;
   insert('.', mantisse1,2);
     end;

   if not(positif) then mantisse2:='-'+mantisse2;


     if length('('+mantisse2+'±'+mantisse1+')')<=longueur_chaine_agreable then
    Donne_Selon_Incertitude:='('+mantisse2+'±'+mantisse1+')' else
    begin
     Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(x,n1,false,mantisse2,exposant2);
 Donne_Selon_Incertitude:='('+mantisse2+'±'+mantisse1+')'+exposant1;
   end;

 exit;
 end;




    if genre_affichage_incertitude=avec_un_chiffre_avant_virgule_pour_incertitude then begin

 Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
     arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   if (exposant1='') or (exposant1='E') then puissance_sans_virgule_incertitude:=0 else
   puissance_sans_virgule_incertitude:=strtoint(copy(exposant1,2,length(exposant1)-1));
    Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(r,puissance_sans_virgule_incertitude,false,mantisse2,exposant2);

    if  nombre_de_chiffres_incertitude>1 then
    if  nombre_de_chiffres_incertitude-1< length(mantisse2)-1 then insert('.',mantisse2,length(mantisse2)-(nombre_de_chiffres_incertitude-1)+1)
     else  begin
   for i:=1 to nombre_de_chiffres_incertitude-length(mantisse2)do mantisse2:='0'+mantisse2;
   insert('.', mantisse2,2);
     end;

     if  nombre_de_chiffres_incertitude>1 then
        insert('.', mantisse1,2);


     exposant1:='E'+inttostr(puissance_sans_virgule_incertitude+nombre_de_chiffres_incertitude-1);
     if not(positif) then mantisse2:='-'+mantisse2;
     if puissance_sans_virgule_incertitude=0 then exposant1:='';

    if length('('+mantisse2+'±'+mantisse1+')'+exposant1)<=longueur_chaine_agreable then
    Donne_Selon_Incertitude:='('+mantisse2+'±'+mantisse1+')'+exposant1 else
    begin
     Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(x,n1,false,mantisse2,exposant2);
 Donne_Selon_Incertitude:='('+mantisse2+'±'+mantisse1+')'+exposant1;
   end;
     exit;
     end;












  if genre_affichage_incertitude=avec_un_chiffre_avant_virgule_pour_valeur then begin

   Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
     arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   if (exposant1='') or (exposant1='E') then puissance_sans_virgule_incertitude:=0 else
   puissance_sans_virgule_incertitude:=strtoint(copy(exposant1,2,length(exposant1)-1));
    Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(r,puissance_sans_virgule_incertitude,false,mantisse2,exposant2);
      lma2:=length(mantisse2);
     if  lma2>1 then
        insert('.', mantisse2,2);


    if  lma2>1 then
    if  lma2-1< length(mantisse1)-1 then insert('.',mantisse1,length(mantisse1)-(lma2-1)+1)
     else  begin
   for i:=1 to lma2-length(mantisse1)do mantisse1:='0'+mantisse1;
   insert('.', mantisse1,2);
     end;


           puissance_sans_virgule_incertitude:=puissance_sans_virgule_incertitude+lma2-1;
     exposant1:='E'+inttostr(puissance_sans_virgule_incertitude);
     if not(positif) then mantisse2:='-'+mantisse2;
     if puissance_sans_virgule_incertitude=0 then exposant1:='';

    if length('('+mantisse2+'±'+mantisse1+')'+exposant1)<=longueur_chaine_agreable then
    Donne_Selon_Incertitude:='('+mantisse2+'±'+mantisse1+')'+exposant1 else
    begin
     Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(abs(incertitude),nombre_de_chiffres_incertitude,-1000,puissance_sans_virgule_incertitude,
 arrondi_superieur_sur_incertitude,mantisse1,exposant1);
   Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(x,n1,false,mantisse2,exposant2);
 Donne_Selon_Incertitude:='('+mantisse2+'±'+mantisse1+')'+exposant1;
   end;
     exit;
     end;



end;

Procedure Donne_Mantisse_Et_Exposant_Avec_Puissance_De_Dix(const x:extended; const puissance_de_dix_souhaitee:integer;
 arrondi_superieur:boolean; var mantisse,exposant:string);

var s:string; positif:boolean; r,y:extended; z,i:integer;  p10:integer;
                   un_caractere_de_plus:boolean;
begin
if isnanorinf(x) then begin
mantisse:='NAN';
exposant:='';
exit;
end;

positif:=(x>0);
r:=abs(x);
r:=r*power(10,-puissance_de_dix_souhaitee);

if r<maxint then  begin
if  arrondi_superieur then z:=ceil(r) else z:=round(r);
if not(positif)  then z:=-z;
mantisse:=inttostr(z);
exposant:='E'+inttostr(puissance_de_dix_souhaitee);
 exit;
end;

{si r est plus grand que maxint}
p10:=floor(ln(r)/ln(10));
y:=r*power(10,-p10);
{y est de la forme a.bcdef...}
s:=floattostrf(y,fffixed,1,20);
s:=copy(s,1,p10+2);
if length(s)<p10+2 then
for i:=1 to p10+2-length(s) do s:=s+'0';
delete(s,2,1);
mantisse:=s;
if not(positif) then mantisse:='-'+mantisse;
 exposant:='E'+inttostr(puissance_de_dix_souhaitee);

end;


Function Rajoute_Zero_Significatif(const s:string):string;
var s1,s2:string; i,j:integer;
  begin
  s1:=''; s2:='';
 i:=pos('e',s);
  if i=0 then  i:=pos('E',s);

  if i<>0 then begin
    s1:=copy(s,1,i-1);
  s2:=copy(s,i,length(s)-i+1);
 end else s1:=s;

if pos('.',s1)<>0 then s1:=s1+'0' else
 s1:=s1+'.0';
Rajoute_Zero_Significatif:=s1+s2;

  end;

Function Puissance_Du_Dernier_Chiffre_Significatif(const s:string):integer;
var i,puissance_de_dix,exposant:integer; r:extended;  s1:string;
  begin
  exposant:=0;
  i:=pos('e',s);
  if i=0 then  i:=pos('E',s);


 if i<>0 then begin
 exposant:=strtoint(copy(s,i+1,length(s)-i));
 s1:=copy(s,1,i-1);
 end else s1:=s;
if s1[1]='-' then delete(s1,1,1);
i:=pos('.',s1);
if i=0 then puissance_de_dix:=exposant else
 puissance_de_dix:=-(length(s1)-i)+exposant;
 Puissance_Du_Dernier_Chiffre_Significatif:=puissance_de_dix;


  end;





  function IncrementeCaractere(c:char):char;
  begin
  if c='0' then IncrementeCaractere:='1';
  if c='1' then IncrementeCaractere:='2';
  if c='2' then IncrementeCaractere:='3';
  if c='3' then IncrementeCaractere:='4';
  if c='4' then IncrementeCaractere:='5';
  if c='5' then IncrementeCaractere:='6';
  if c='6' then IncrementeCaractere:='7';
  if c='7' then IncrementeCaractere:='8';
  if c='8' then IncrementeCaractere:='9';
  if c='9' then IncrementeCaractere:='0';
  end;

  Function IncrementeChaine(const s:string; var un_caractere_de_plus:boolean):string;
 {rajoute 1 à une chaine de caractere representant un nombre entier}
 var position,longueur:integer;  s1:string;  retenue:boolean;   c:char;
begin
un_caractere_de_plus:=false;
s1:=s;
 if s1='9' then begin
 s1:='10';
 un_caractere_de_plus:=true;
 IncrementeChaine:=s1;
 exit;
 end;

 longueur:=length(s1);
 retenue:=false;
 if s1[longueur] in ['0'..'8'] then begin
 c:=IncrementeCaractere(s1[longueur]);
 s1[longueur]:=c;
 IncrementeChaine:=s1;
 exit;
 end
 else begin
 retenue:=true;
 s1[longueur]:='0';
 position:=longueur-1;
 end;

 while (retenue) and  (position>0) do begin
if s1[position] in ['0'..'8'] then begin
c:=IncrementeCaractere(s1[position]);
 s1[position]:=c;
 retenue:=false;
 IncrementeChaine:=s1;
 exit;
 end else begin
  retenue:=true;
 s1[position]:='0';
 dec(position);
   end; end;

if (retenue) and (position=0) then begin
s1:='1'+s1;
IncrementeChaine:=s1;
un_caractere_de_plus:=true;
exit;
end;

IncrementeChaine:=s1;
 end;

  function EgaliteReels(n1,n2 : extended) : boolean;
begin
  result := Abs(n1 - n2) < Min(abs(n1),abs(n2)) * 1E-16;
end;



  Function Donne_Avec_Chiffres_Significatifs(const x:extended; const nombre_chiffres_significatifs:integer;
  genre_affichage_valeur_individuelle:type_affichage_valeur_individuelle; longueur_chaine_agreable:integer):string;
  var pp,po:integer;    s:string;
  begin
  Donne_Avec_Chiffres_Significatifs2(x,nombre_chiffres_significatifs,-10000,po,false);

   if (genre_affichage_valeur_individuelle=_avec_un_chiffre_avant_virgule) then   begin
  Donne_Avec_Chiffres_Significatifs:=Donne_Avec_Chiffres_Significatifs2(x,nombre_chiffres_significatifs,po+nombre_chiffres_significatifs-1,po,false);
  exit;
   end;

  if (genre_affichage_valeur_individuelle=_sans_puissance_de_dix) and (length(Donne_Avec_Chiffres_Significatifs2(x,nombre_chiffres_significatifs,0,po,false))<longueur_chaine_agreable) then
 Donne_Avec_Chiffres_Significatifs:=Donne_Avec_Chiffres_Significatifs2(x,nombre_chiffres_significatifs,0,po,false)
 else
 Donne_Avec_Chiffres_Significatifs:=Donne_Avec_Chiffres_Significatifs2(x,nombre_chiffres_significatifs,-10000,po,false);

  end;

  Function Donne_Avec_Chiffres_Significatifs_Arrondi_Superieur(const x:extended; const nombre_chiffres_significatifs:integer;
  genre_affichage_valeur_individuelle:type_affichage_valeur_individuelle; longueur_chaine_agreable:integer):string;
   var pp,po:integer;      s:string;
  begin
  Donne_Avec_Chiffres_Significatifs2(x,nombre_chiffres_significatifs,-10000,po,true);

   if (genre_affichage_valeur_individuelle=_avec_un_chiffre_avant_virgule) then   begin
  Donne_Avec_Chiffres_Significatifs_Arrondi_Superieur:=Donne_Avec_Chiffres_Significatifs2(x,nombre_chiffres_significatifs,po+nombre_chiffres_significatifs-1,po,true);
  exit;
   end;

  if (genre_affichage_valeur_individuelle=_sans_puissance_de_dix) and (length(Donne_Avec_Chiffres_Significatifs2(x,nombre_chiffres_significatifs,0,po,false))<longueur_chaine_agreable) then
 Donne_Avec_Chiffres_Significatifs_Arrondi_Superieur:=Donne_Avec_Chiffres_Significatifs2(x,nombre_chiffres_significatifs,0,po,true)
 else
 Donne_Avec_Chiffres_Significatifs_Arrondi_Superieur:=Donne_Avec_Chiffres_Significatifs2(x,nombre_chiffres_significatifs,-10000,po,true);
  end;

Function Donne_Avec_Chiffres_Significatifs2(const x:extended; const nombre_chiffres_significatifs:integer; puissance_de_dix_souhaitee:integer;
var puissance_de_dix_pour_ne_pas_avoir_de_virgule:integer; arrondi_superieur:boolean):string;
var mant,expo:string;
                   begin
 Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(x,nombre_chiffres_significatifs,puissance_de_dix_souhaitee,puissance_de_dix_pour_ne_pas_avoir_de_virgule,
 arrondi_superieur,mant,expo);
  Donne_Avec_Chiffres_Significatifs2:=mant+expo;
  end;

Procedure Donne_Mantisse_Et_Exposant_Avec_Chiffres_Significatifs(const x:extended; const nombre_chiffres_significatifs:integer; puissance_de_dix_souhaitee:integer;
var puissance_de_dix_pour_ne_pas_avoir_de_virgule:integer; arrondi_superieur:boolean; var mantisse,exposant:string);

var s:string; signe:boolean; r,dix_test:extended; puissance_de_dix,puissance_de_dix_sup,i:integer;   dix_chf:integer;
                   un_caractere_de_plus:boolean;
begin
if isnanorinf(x) then begin
mantisse:='NAN';
exposant:='';
exit;
end;

if nombre_chiffres_significatifs<1 then begin
mantisse:='Impossible';
exposant:='';
exit;
end;

puissance_de_dix_sup:=0;


if (x=0) then begin
if  nombre_chiffres_significatifs=1 then
begin
mantisse:='0';
exposant:='';
exit;
end;
s:='0.';
for i:=1 to nombre_chiffres_significatifs
do s:=s+'0';
mantisse:=s;
exposant:='';
exit;
end;

signe:=(x>0);
r:=abs(x);

puissance_de_dix:=floor(ln(r)/ln(10));

{traitement des valeurs du genre 0.99999999999999999 considéré comme1}
dix_test:=1;
if puissance_de_dix>0 then for i:=1 to puissance_de_dix do dix_test:=dix_test*10;
if puissance_de_dix<0 then for i:=1 to -puissance_de_dix do dix_test:=dix_test/10;
dix_test:=dix_test*10;
 if EgaliteReels(r,dix_test) then puissance_de_dix:=puissance_de_dix+1;


if  puissance_de_dix>0 then for i:=1 to puissance_de_dix do r:=r/10
else  if  puissance_de_dix<0 then for i:=1 to -puissance_de_dix do r:=r*10;
s:=floattostrf(r,fffixed,1,20);
delete(s,2,1);
if length(s)<nombre_chiffres_significatifs+1 then
for i:=1 to nombre_chiffres_significatifs+1-length(s) do s:=s+'0';

if not(arrondi_superieur) then
if strtoint(s[nombre_chiffres_significatifs+1])<=4 then
s:=copy(s,1,nombre_chiffres_significatifs) else
if  (strtoint(s[nombre_chiffres_significatifs+1])>=5)
 then begin
s:=IncrementeChaine(copy(s,1,nombre_chiffres_significatifs),un_caractere_de_plus);
if un_caractere_de_plus then puissance_de_dix_sup:=1;
s:=copy(s,1,nombre_chiffres_significatifs);
   end;

if arrondi_superieur then
if strtoint(s[nombre_chiffres_significatifs+1])=0 then
s:=copy(s,1,nombre_chiffres_significatifs) else
if  (strtoint(s[nombre_chiffres_significatifs+1])>=1)
 then begin
s:=IncrementeChaine(copy(s,1,nombre_chiffres_significatifs),un_caractere_de_plus);
if un_caractere_de_plus then puissance_de_dix_sup:=1;
s:=copy(s,1,nombre_chiffres_significatifs);
   end;



    {nouvelle version}
 puissance_de_dix:=puissance_de_dix+puissance_de_dix_sup-length(s)+1;
 puissance_de_dix_pour_ne_pas_avoir_de_virgule:=puissance_de_dix;
 {donc la chaine est sEpuissance_de_dix}
if (puissance_de_dix_souhaitee<puissance_de_dix) then  puissance_de_dix_souhaitee:=puissance_de_dix;

if  (puissance_de_dix_souhaitee>puissance_de_dix) then begin
if   (puissance_de_dix_souhaitee-puissance_de_dix<length(s)) then
insert('.',s,length(s)+1-(puissance_de_dix_souhaitee-puissance_de_dix)) else
 begin
 for i:=1 to  puissance_de_dix_souhaitee-puissance_de_dix-length(s) do s:='0'+s;
 s:='0.'+s;
 end;
end;


exposant:='';
if puissance_de_dix_souhaitee<>0 then exposant:='E'+inttostr(puissance_de_dix_souhaitee);
if not(signe) then insert('-',s,1);
mantisse:=s;

 end;
{fin nouvelle version}

procedure Copie_Distribution(const source:extendedarray; var destination:extendedarray; const nombre:longint);
var i:longint;
begin
setlength(destination,nombre);
for i:=1 to nombre  do
destination[i-1]:=source[i-1];
end;


function Trapeze_Densite(const moyenne,demi_etendue_bas,demi_etendue_haut,x:extended):extended;
begin
if (x<=moyenne-demi_etendue_bas) then begin
Trapeze_Densite:=0;
exit;
end;
if (x>=moyenne+demi_etendue_bas) then begin
Trapeze_Densite:=0;
exit;
end;
if ((x<=moyenne-demi_etendue_haut) and (x>=moyenne-demi_etendue_bas) ) then begin
Trapeze_Densite:=(x-moyenne+demi_etendue_bas)/(sqr(demi_etendue_bas)-sqr(demi_etendue_haut));
exit;
end;
if ((x>=moyenne+demi_etendue_haut) and (x<=moyenne+demi_etendue_bas) ) then begin
Trapeze_Densite:=(-x+moyenne+demi_etendue_bas)/(sqr(demi_etendue_bas)-sqr(demi_etendue_haut));
exit;
end;
Trapeze_Densite:=1/(demi_etendue_bas+demi_etendue_haut);
end;

function Trapeze_Integree(const moyenne,demi_etendue_bas,demi_etendue_haut,x:extended):extended;
begin
if (x<=moyenne-demi_etendue_bas) then begin
Trapeze_Integree:=0;
exit;
end;
if (x>=moyenne+demi_etendue_bas) then begin
Trapeze_Integree:=1;
exit;
end;
if ((x<=moyenne-demi_etendue_haut) and (x>=moyenne-demi_etendue_bas) ) then begin
Trapeze_Integree:=(x-moyenne+demi_etendue_bas)*Trapeze_Densite(moyenne,demi_etendue_bas,demi_etendue_haut,x)/2;
exit;
end;
if ((x>=moyenne-demi_etendue_haut) and (x<=moyenne+demi_etendue_haut) ) then begin
Trapeze_Integree:=1/(demi_etendue_bas+demi_etendue_haut)*
(x-moyenne+demi_etendue_haut+(demi_etendue_bas-demi_etendue_haut)/2);
exit;
end;
Trapeze_Integree:=1/(demi_etendue_bas+demi_etendue_haut)*
(2*demi_etendue_haut+(demi_etendue_bas-demi_etendue_haut)/2)+
1/(demi_etendue_bas+demi_etendue_haut)/2*(demi_etendue_bas-demi_etendue_haut)-
(moyenne+demi_etendue_bas-x)*Trapeze_Densite(moyenne,demi_etendue_bas,demi_etendue_haut,x)/2;
end;








function Derivee_D_Arcsinus_Densite(const moyenne,demi_etendue,x:extended):extended;
begin
if ((x>=moyenne+demi_etendue) or (x<=moyenne-demi_etendue)) then begin
Derivee_D_Arcsinus_Densite:=0;
exit;
end;
Derivee_D_Arcsinus_Densite:=1/Pi/demi_etendue/sqrt(1-sqr((x-moyenne)/demi_etendue));
end;

function Derivee_D_Arcsinus_Integree(const moyenne,demi_etendue,x:extended):extended;
 begin
if (x>=moyenne+demi_etendue)  then begin
Derivee_D_Arcsinus_Integree:=1;
exit;
end;
if (x<=moyenne-demi_etendue)  then begin
Derivee_D_Arcsinus_Integree:=0;
exit;
end;

Derivee_D_Arcsinus_Integree:=1/Pi*(arcsin((x-moyenne)/demi_etendue)+Pi/2);
end;


function Triangulaire_Densite(const moyenne,demi_etendue,x:extended):extended;
begin
if ((x<moyenne-demi_etendue) or (x>moyenne+demi_etendue)) then begin
Triangulaire_Densite:=0;
exit;
end;
if x<moyenne then  Triangulaire_Densite:=(x-(moyenne-demi_etendue))/sqr(demi_etendue)
else Triangulaire_Densite:=-(x-(moyenne+demi_etendue))/sqr(demi_etendue);
     end;

function Triangulaire_Integree(const moyenne,demi_etendue,x:extended):extended;
begin
if  (x<moyenne-demi_etendue) then begin
Triangulaire_Integree:=0;
exit;
end;
if  (x>moyenne+demi_etendue) then begin
Triangulaire_Integree:=1;
exit;
end;
if x<=moyenne then begin
Triangulaire_Integree:=sqr(x-moyenne+demi_etendue)/2/sqr(demi_etendue);
exit;
end;
Triangulaire_Integree:=(-x*x+2*(moyenne+demi_etendue)*(x-moyenne)+moyenne*moyenne)/2/sqr(demi_etendue)+0.5;
end;


function Normale_Integree(const moyenne,ecart_type:extended; const x:extended):extended;
begin
Normale_Integree:=normstd_cdfx((x-moyenne)/ecart_type);
end;


function Normale_Densite(const moyenne,ecart_type:extended; const  x:extended):extended;
begin
Normale_Densite:=1/ecart_type*normstd_pdfx((x-moyenne)/ecart_type);
end;



function Rectangulaire_Densite(const moyenne,demi_etendue,x:extended):extended;
begin
if ((x<moyenne-demi_etendue) or (x>moyenne+demi_etendue)) then Rectangulaire_Densite:=0 else
Rectangulaire_Densite:=1/2/demi_etendue;
end;

function Rectangulaire_Integree(const moyenne,demi_etendue,x:extended):extended;
begin
if  (x<moyenne-demi_etendue) then begin
Rectangulaire_Integree:=0;
exit;
end;
if  (x>moyenne+demi_etendue) then begin
Rectangulaire_Integree:=1;
exit;
end;
Rectangulaire_Integree:=1/2/demi_etendue*(x-moyenne+demi_etendue);
end;

function Uniforme_Integree(const x:extended):extended;
begin
if x<0 then begin
Uniforme_Integree:=0;
exit;
end;
if x>1 then begin
Uniforme_Integree:=1;
exit;
end;
Uniforme_Integree:=x;
end;




function Uniforme_Densite(const  x:extended):extended;
begin
if ((x<0) or (x>1)) then  Uniforme_Densite:=0 else Uniforme_Densite:=1;
end;




procedure Intervalle_Recouvrement_Le_Plus_Court(const pourcentage:extended; const donnees:extendedarray;
const nombre:longint; var borne_inf,borne_sup:extended);
var i,q,indice:longint;  largeur:extended;
begin
q:=trunc(pourcentage*nombre+0.5);
largeur:=donnees[q]-donnees[0]; indice:=0;
for i:=1 to nombre-q-1  do
if donnees[q+i]-donnees[i]< largeur then begin
largeur:=donnees[q+i]-donnees[i];
indice:=i;
end;
borne_inf:=donnees[indice];
borne_sup:=donnees[q+indice];

end;

procedure Intervalle_Recouvrement_Symetrique(const pourcentage:extended; const donnees:extendedarray;
const nombre:longint; var borne_inf,borne_sup:extended);
var i,q,indice:longint;
begin
q:=trunc(pourcentage*nombre+0.5);
indice:=trunc((nombre-q+1)/2);
borne_inf:=donnees[indice-1];
borne_sup:=donnees[indice-1+q];
end;

 procedure Intervalle_Recouvrement_Symetrique_Par_Rapport_A_La_Moyenne(const pourcentage:extended; const donnees:extendedarray;
const nombre:longint; const moyenne:extended; var borne_inf,borne_sup:extended);
var i,q,indicedelamoyenne:longint;  ecart:extended;
begin
q:=trunc(pourcentage*nombre/2+0.5);
indicedelamoyenne:=0; ecart:=abs(donnees[0]-moyenne);
for i:=1 to nombre-1 do
if abs(donnees[i]-moyenne)<ecart then begin
 indicedelamoyenne:=i;
 ecart:=abs(donnees[i]-moyenne);
  end;

if   (indicedelamoyenne-q<0) or (indicedelamoyenne+q>nombre-1) then
  Intervalle_Recouvrement_Symetrique(pourcentage,donnees,nombre,borne_inf,borne_sup) else
  begin
 borne_inf:=donnees[indicedelamoyenne-q];
borne_sup:=donnees[indicedelamoyenne+q];


  end;


end;

function Student_Densite(const moyenne,ecart_type:extended;const  degres_de_liberte:longint; const x:extended):extended;
begin
Student_Densite:=t_pdfx(degres_de_liberte,(x-moyenne)/ecart_type*sqrt(degres_de_liberte+1))/ecart_type*sqrt(degres_de_liberte+1);
end;

function Student_Integree(const moyenne,ecart_type:extended; const degres_de_liberte:longint;const  x:extended):extended;
begin
Student_Integree:=t_cdfx(degres_de_liberte,(x-moyenne)/ecart_type*sqrt(degres_de_liberte+1));
end;




function Fonction_Distribution(const donnees:extendedarray;const  nombre:longint;const  x:extended):extended;
var i:integer;
begin
if x<donnees[0] then begin
Fonction_Distribution:=0;
exit;end;

if x>donnees[nombre-1] then begin
Fonction_Distribution:=1;
exit;end;

if x=donnees[0] then begin
Fonction_Distribution:=1/2/nombre;
exit;end;

if x=donnees[nombre-1] then begin
Fonction_Distribution:=(nombre-1/2)/nombre;
exit;end;

i:=1;
repeat inc(i); until (x<donnees[i-1]) ;
if x=donnees[i-2] then  Fonction_Distribution:=(i-1-1/2)/nombre else
Fonction_Distribution:=(i-1-1/2)/nombre+(x-donnees[i-2])/nombre/(donnees[i-1]-donnees[i-2]);
end;




procedure Decale_Doublons(VAR arr: extendedarray; const nombre:longint);
var i,j,k:longint;
begin
for i:=1 to nombre-1 do

if arr[i-1]=arr[i] then begin
{on cherche un suivant ou un précédent différent}


if i<nombre-1 then begin
j:=i;
repeat
inc(j) until  ( (arr[j]>arr[i]) or (j=nombre-1) );
if (arr[j]>arr[i]) then begin
arr[i]:=arr[i-1]+(arr[j]-arr[i])/100;
if j>i+1 then for k:=i+1 to j-1 do arr[k]:=arr[i];
end;  end;

if ((arr[i-1]=arr[i]) and (i>1)) then
begin
j:=i-1;
repeat dec(j) until ( (arr[j]<arr[i]) or (j=0) );
if (arr[j]<arr[i]) then
arr[i-1]:=arr[i]-abs(arr[i]-arr[j])/100;
end;


  end;
end;



procedure Tri_Rapide(VAR arr: extendedarray; const size:longint);

        PROCEDURE QuicksortRecur(start, stop: integer);
            VAR
                m: integer;
                               splitpt: integer;


            FUNCTION Split(start, stop: integer): integer;
                VAR
                    left, right: integer;
                    pivot: extended;

                             PROCEDURE swap(VAR a, b: extended);
                    VAR
                        t: extended;
                    BEGIN
                        t := a;
                        a := b;
                        b := t
                    END;

                BEGIN
                    pivot := arr[start];
                    left := start + 1;
                    right := stop;

                                      WHILE left <= right DO BEGIN
                        WHILE (left <= stop) AND (arr[left] < pivot) DO
                            left := left + 1;
                        WHILE (right > start) AND (arr[right] >= pivot) DO
                            right := right - 1;
                        IF left < right THEN
                            swap(arr[left], arr[right]);
                    END;

                                     swap(arr[start], arr[right]);

                    Split := right
                END;

            BEGIN
                                IF start < stop THEN BEGIN
                    splitpt := Split(start, stop);
                    QuicksortRecur(start, splitpt-1);
                    QuicksortRecur(splitpt+1, stop);
                END
            END;

        BEGIN
            QuicksortRecur(0, size-1)
        END;


procedure Initialise_Generateur(seed:longint);
begin
isaac_init(rng,seed);
end;

{genere une distribution uniforme dans l'intervalle [0,1]}
procedure Genere_Uniforme_Dans01(var res:extendedarray; const nombre:longint);
var i:longint;
begin
 setlength(res,nombre);
     for i:=1 to nombre do res[i-1]:=isaac_double(rng);
  end;

procedure Genere_Gamma(var res:extendedarray; const nombre:longint; const alpha,beta:extended);
var a,b,d,q,theta,v,y,z,w:extended; i:longint; u1,u2:extended;
begin
 setlength(res,nombre);
 a:=1/sqrt(2*alpha-1);
b:=alpha-ln(4);
q:=alpha+(1/a);
 theta:=4.5;
 d:=1+ln(theta);
 for i:=1 to nombre do
       begin
       repeat
       repeat
      u1:=isaac_double(rng);
      until u1<>1;
      u2:=isaac_double(rng);
       v:=a*ln(u1/(1-u1));
       y:=alpha*exp(v);
        z:=u1*u1*u2;
          w:=b+q*v-y;
              until ((w+d-theta*z >=0) or  (w>=ln(z)));
              res[i-1]:=beta*y;
       end;
       end;

procedure Genere_Student(var res:extendedarray;const  nombre:longint; const moyenne,ecart_type:extended; const degre_de_liberte:longint);
var alpha,beta,a,b,d,q,theta,v,y,z,w:extended; i:longint; u1,u2,x1,x2,rr1,rr2:extended;
begin
 setlength(res,nombre);
 alpha:=degre_de_liberte/2; beta:=2;
 a:=1/sqrt(2*alpha-1);
b:=alpha-ln(4);
q:=alpha+(1/a);
 theta:=4.5;
 d:=1+ln(theta);
for i:=1 to nombre do  begin
{on genere rr1 issu d'une distrib normale (0,1}
repeat
 x1:=2*isaac_double(rng)-1;
x2:=2*isaac_double(rng)-1;
w:=x1*x1+x2*x2;
until w<1;
w := sqrt( (-2.0 * ln( w ) ) / w );
rr1:=x1*w;
{on genere rr2 issu d'une distrib gamma (0.5degre,2}
repeat
repeat
      u1:=isaac_double(rng);
      until u1<>1;
      u2:=isaac_double(rng);
       v:=a*ln(u1/(1-u1));
       y:=alpha*exp(v);
        z:=u1*u1*u2;
          w:=b+q*v-y;
              until ((w+d-theta*z >=0) or  (w>=ln(z)));
     rr2:=beta*y;
     res[i-1]:=rr1/sqrt(rr2/degre_de_liberte)*ecart_type/sqrt(degre_de_liberte+1)+moyenne;
end;
end;

procedure Genere_Trapeze(var res:extendedarray; const nombre:longint; const moyenne,demi_etendue_bas,demi_etendue_haut:extended);
var x1,x2,z,beta:extended;  i:longint;
begin
 setlength(res,nombre);
   z:=moyenne-demi_etendue_bas;  beta:=demi_etendue_haut/demi_etendue_bas;
   for i:=1 to nombre do  begin
    x1:=isaac_double(rng);
    x2:=isaac_double(rng);
    res[i-1]:=z+demi_etendue_bas*((1+beta)*x1+(1-beta)*x2);
   end;
 end;

{genere une distribution normale}
procedure Genere_Normale(var res:extendedarray; const nombre:longint; const moyenne,ecart_type:extended);
var i:longint; x1,x2,w:extended;
begin
 setlength(res,nombre);
for i:=1 to nombre do begin
  repeat
  x1:=2*isaac_double(rng)-1;
x2:=2*isaac_double(rng)-1;
w:=x1*x1+x2*x2;
until w<1;
w := sqrt( (-2.0 * ln( w ) ) / w );
res[i-1]:=moyenne+ecart_type*x1*w;
  end;
 end;


{genere une distribution binormale}
procedure Genere_BiNormale(var res1,res2:extendedarray; const nombre:longint; const moyenne1,ecart_type1,moyenne2,ecart_type2,coef_correlation:extended);
var res3,res4:extendedarray;  i:integer;
    begin
 setlength(res1,nombre);  setlength(res2,nombre); setlength(res3,nombre); setlength(res4,nombre);
 Genere_Normale(res3,nombre,0,1);
 Genere_Normale(res4,nombre,0,1);
 for i:=1 to nombre do begin
  res1[i-1]:=moyenne1+ecart_type1*res3[i-1];
  res2[i-1]:=moyenne2+ecart_type2*(coef_correlation*res3[i-1]+sqrt(1-sqr(coef_correlation))*res4[i-1]);
 end;

    end;

procedure Genere_Triangulaire(var res:extendedarray; const nombre:longint; const moyenne,demi_etendue:extended);
var i:longint; w:extended;
begin
 setlength(res,nombre);
for i:=1 to nombre do begin
  w:=isaac_double(rng);
  if w<=0.5  then res[i-1]:=demi_etendue*sqrt(2*w)+moyenne-demi_etendue else
  res[i-1]:=demi_etendue*(1-sqrt(2*(1-w)))+moyenne;
  end;
 end;

procedure Genere_Derivee_D_Arcsinus(var res:extendedarray; const nombre:longint; const moyenne,demi_etendue:extended);
 var i:longint; w:extended;
begin
 setlength(res,nombre);
for i:=1 to nombre do begin
  w:=isaac_double(rng);
  res[i-1]:=-demi_etendue*cos(Pi*w)+moyenne;
  end;
 end;



procedure Genere_Rectangulaire(var res:extendedarray; const nombre:longint;const  moyenne,demi_etendue:extended);
var i:longint; w:extended;
begin
 setlength(res,nombre);
for i:=1 to nombre do begin
  w:=isaac_double(rng);
  res[i-1]:=moyenne-demi_etendue+w*2*demi_etendue;
  end;
 end;


function Calcule_Covariance(const donnees1,donnees2:extendedarray; const nombre:longint; var covariance:extended):boolean;
   var est_multiple_de_10:boolean;  i,j,nb:longint;  do1,do2,do3,do4,do5,do6:extendedarray;
       moyenne_a,moyenne_b,moyenne_ab:extended;
   begin
   Calcule_Covariance:=true;
    for i:=1 to nombre do
  if  ((isnanorinfinite(donnees1[i-1])) or (isnanorinfinite(donnees2[i-1])) ) then begin
    covariance:=NAN;
   Calcule_Covariance:=false;
    exit
    end;

  est_multiple_de_10:=((nombre mod 10)=0);
  Calcule_Covariance:=est_multiple_de_10;
  if not(est_multiple_de_10) then exit;

  nb:=nombre;
     setlength(do1,nb);
     for i:=1 to nb do do1[i-1]:=donnees1[i-1];
    setlength(do3,nb);
     for i:=1 to nb do do3[i-1]:=donnees2[i-1];
       setlength(do5,nb);
     for i:=1 to nb do do5[i-1]:=donnees1[i-1]*donnees2[i-1];

     while ((nb mod 10)=0) do begin
          nb:=nb div 10;
    setlength(do2,nb);    setlength(do4,nb);   setlength(do6,nb);
    for i:=1 to nb do
    begin
    do2[i-1]:=0;  do4[i-1]:=0;  do6[i-1]:=0;
    for j:=1 to 10 do do2[i-1]:=do2[i-1]+do1[(i-1)*10+j-1];
    for j:=1 to 10 do do4[i-1]:=do4[i-1]+do3[(i-1)*10+j-1];
     for j:=1 to 10 do do6[i-1]:=do6[i-1]+do5[(i-1)*10+j-1];
    do2[i-1]:=do2[i-1]/10;   do4[i-1]:=do4[i-1]/10;  do6[i-1]:=do6[i-1]/10;
    end;
    setlength(do1,nb);
    for i:=1 to nb do do1[i-1]:=do2[i-1];
    setlength(do3,nb);
    for i:=1 to nb do do3[i-1]:=do4[i-1];
    setlength(do5,nb);
    for i:=1 to nb do do5[i-1]:=do6[i-1];
      end;
    moyenne_a:=0;
    for i:=1 to nb do moyenne_a:=moyenne_a+do1[i-1];
    moyenne_a:=moyenne_a/nb;
     moyenne_b:=0;
    for i:=1 to nb do moyenne_b:=moyenne_b+do3[i-1];
    moyenne_b:=moyenne_b/nb;
    moyenne_ab:=0;
    for i:=1 to nb do moyenne_ab:=moyenne_ab+do5[i-1];
    moyenne_ab:=moyenne_ab/nb;

    covariance:=moyenne_ab-moyenne_a*moyenne_b;



   end;

 function Calcule_Moyenne_Et_Ecart_Type(const donnees:extendedarray; const nombre:longint; var moyenne,ecart_type,skewness,kurtosis:extended):boolean;
   var est_multiple_de_10:boolean;  i,j,nb:longint;  do1,do2,do3,do4,do5,do6,do7,do8:extendedarray;
       moyenne_x,moyenne_x2,moyenne_x3,moyenne_x4,m3,m4:extended;
   begin

    Calcule_Moyenne_Et_Ecart_Type:=true;
for i:=1 to nombre do
  if isnanorinfinite(donnees[i-1]) then begin
    moyenne:=NAN;
    ecart_type:=NAN;
   Calcule_Moyenne_Et_Ecart_Type:=false;
   skewness:=NAN;
   kurtosis:=NAN;
    exit
    end;

 { est_multiple_de_10:=((nombre mod 10)=0);
  Calcule_Moyenne_Et_Ecart_Type:=est_multiple_de_10;
  if not(est_multiple_de_10) then exit;

  nb:=nombre;
     setlength(do1,nb);
     for i:=1 to nb do do1[i-1]:=donnees[i-1];
    setlength(do3,nb);
     for i:=1 to nb do do3[i-1]:=donnees[i-1]*donnees[i-1];
      setlength(do5,nb);
     for i:=1 to nb do do5[i-1]:=donnees[i-1]*donnees[i-1]*donnees[i-1];
     setlength(do7,nb);
     for i:=1 to nb do do7[i-1]:=donnees[i-1]*donnees[i-1]*donnees[i-1]*donnees[i-1];

     while ((nb mod 10)=0) do begin
          nb:=nb div 10;
    setlength(do2,nb);    setlength(do4,nb);   setlength(do6,nb);  setlength(do8,nb);
    for i:=1 to nb do
    begin
    do2[i-1]:=0;  do4[i-1]:=0;    do6[i-1]:=0;  do8[i-1]:=0;
    for j:=1 to 10 do do2[i-1]:=do2[i-1]+do1[(i-1)*10+j-1];
    for j:=1 to 10 do do4[i-1]:=do4[i-1]+do3[(i-1)*10+j-1];
     for j:=1 to 10 do do6[i-1]:=do6[i-1]+do5[(i-1)*10+j-1];
      for j:=1 to 10 do do8[i-1]:=do8[i-1]+do7[(i-1)*10+j-1];
    do2[i-1]:=do2[i-1]/10;   do4[i-1]:=do4[i-1]/10;
     do6[i-1]:=do6[i-1]/10;   do8[i-1]:=do8[i-1]/10;
    end;
    setlength(do1,nb);
    for i:=1 to nb do do1[i-1]:=do2[i-1];
    setlength(do3,nb);
    for i:=1 to nb do do3[i-1]:=do4[i-1];
     setlength(do5,nb);
    for i:=1 to nb do do5[i-1]:=do6[i-1];
    setlength(do7,nb);
    for i:=1 to nb do do7[i-1]:=do8[i-1];
      end;
    moyenne_x:=0;
    for i:=1 to nb do moyenne_x:=moyenne_x+do1[i-1];
    moyenne_x:=moyenne_x/nb;
    moyenne:=moyenne_x;
     moyenne_x2:=0;
    for i:=1 to nb do moyenne_x2:=moyenne_x2+do3[i-1];
    moyenne_x2:=moyenne_x2/nb;
    ecart_type:=sqrt(1.0*nombre/(nombre-1)*(moyenne_x2-moyenne*moyenne));

    moyenne_x3:=0;
    for i:=1 to nb do moyenne_x3:=moyenne_x3+do5[i-1];
    moyenne_x3:=moyenne_x3/nb;

    moyenne_x4:=0;
     for i:=1 to nb do moyenne_x4:=moyenne_x4+do7[i-1];
    moyenne_x4:=moyenne_x4/nb;

    skewness:=1.0*nombre*nombre/(nombre-1)/(nombre-2)/(ecart_type*ecart_type*ecart_type)*(moyenne_x3+2*moyenne_x*moyenne_x*moyenne_x-3*moyenne_x*moyenne_x2);
    kurtosis:=1.0*nombre*nombre*(nombre+1)/(nombre-1)/(nombre-2)/(nombre-3)/(ecart_type*ecart_type*ecart_type*ecart_type)*(moyenne_x4-4*moyenne_x*moyenne_x3+6*moyenne_x2*moyenne_x*moyenne_x
    -3*moyenne_x*moyenne_x*moyenne_x*moyenne_x)-3.0/(nombre-2)/(nombre-3)*(nombre-1)*(nombre-1); }

   AMath. momentx(donnees,nombre,moyenne,ecart_type,m3,m4,skewness,kurtosis);
   kurtosis:=kurtosis-3;
    end;


 function Statistiques_Par_Classe_2D(const donnees_x,donnees_y:extendedarray; const nombre:longint; const nombre_classes_x,nombre_classes_y:longint;
var bornes_x,bornes_y:extendedarray;
var effectifs:longintarray2D; var densites:extendedarray2D ;var effectif_max:longint; var densite_max:extended):boolean;
 var xmin,xmax,ymin,ymax:extended; i,j,indicex,indicey,jx,jy:integer;  largeur_x,largeur_y:extended;
 begin
   Statistiques_Par_Classe_2D:=true;
   for i:=1 to nombre do
  if ((isnanorinfinite(donnees_x[i-1])) or (isnanorinfinite(donnees_y[i-1]))) then begin
  Statistiques_Par_Classe_2D:=false;
    exit
    end;
 xmin:=donnees_x[0]; xmax:=xmin;
  ymin:=donnees_y[0]; ymax:=ymin;
 for i:=1 to nombre-1 do begin
 xmin:=min(xmin,donnees_x[i]);
 xmax:=max(xmax,donnees_x[i]);
 ymin:=min(ymin,donnees_y[i]);
 ymax:=max(ymax,donnees_y[i]);
 end;
 setlength(bornes_x,nombre_classes_x+1);
 setlength(bornes_y,nombre_classes_y+1);
 setlength(effectifs,nombre_classes_x,nombre_classes_y);
 setlength(densites,nombre_classes_x,nombre_classes_y);
 effectif_max:=0;
 for i:=1 to nombre_classes_x do
  for j:=1 to nombre_classes_y do effectifs[i-1,j-1]:=0;
 largeur_x:=(xmax-xmin)/nombre_classes_x;
 largeur_y:=(ymax-ymin)/nombre_classes_y;
 for i:=1 to nombre_classes_x+1 do bornes_x[i-1]:=xmin+largeur_x*(i-1);
  for i:=1 to nombre_classes_y+1 do bornes_y[i-1]:=ymin+largeur_y*(i-1);
 for i:=1 to nombre do begin
 if donnees_x[i-1]=xmax then jx:=nombre_classes_x else
 jx:=floor((donnees_x[i-1]-xmin)/largeur_x)+1;
 if donnees_y[i-1]=ymax then jy:=nombre_classes_y else
 jy:=floor((donnees_y[i-1]-ymin)/largeur_y)+1;
 inc(effectifs[jx-1,jy-1]);
 end;

 effectif_max:=0; indicex:=0; indicey:=0;

 for i:=1 to nombre_classes_x do
 for j:=1 to nombre_classes_y do begin
 if effectifs[i-1,j-1]>effectif_max then begin
 indicex:=i; indicey:=j;
 effectif_max:=effectifs[i-1,j-1];
 end;
 densites[i-1,j-1]:=effectifs[i-1,j-1]/nombre/largeur_x/largeur_y;
 end;
 densite_max:=densites[indicex-1,indicey-1];

 end;

 function Statistiques_Par_Classe(const donnees:extendedarray; const nombre:longint; const nombre_classes:longint; var bornes:extendedarray;
var effectifs:longintarray; var densites:extendedarray ;var effectif_max:longint; var densite_max:extended):boolean;
 var xmin,xmax:extended; i,j,indice:integer;  largeur:extended;
 begin
   Statistiques_Par_Classe:=true;
   for i:=1 to nombre do
  if isnanorinfinite(donnees[i-1]) then begin
  Statistiques_Par_Classe:=false;
    exit
    end;
 xmin:=donnees[0]; xmax:=xmin;
 for i:=1 to nombre-1 do begin
 xmin:=min(xmin,donnees[i]);
 xmax:=max(xmax,donnees[i]);
 end;
 setlength(bornes,nombre_classes+1);
 setlength(effectifs,nombre_classes);
 setlength(densites,nombre_classes);
 effectif_max:=0;
 for i:=1 to nombre_classes do effectifs[i-1]:=0;
 largeur:=(xmax-xmin)/nombre_classes;
 for i:=1 to nombre_classes+1 do bornes[i-1]:=xmin+largeur*(i-1);
 for i:=1 to nombre do begin
 if donnees[i-1]=xmax then j:=nombre_classes else
 j:=floor((donnees[i-1]-xmin)/largeur)+1;
 inc(effectifs[j]);
 end;
 effectif_max:=0; indice:=0;
 for i:=1 to nombre_classes do begin
 if effectifs[i-1]>effectif_max then begin
 indice:=i;
 effectif_max:=effectifs[i-1];
 end;
 densites[i-1]:=effectifs[i-1]/nombre/largeur;
 end;
 densite_max:=densites[indice-1];
 end;
end.

