{  This file is part of Reg_Lin_Mc, uncertainty calculation software
    Copyright (C) 2013  Jean-Marie Biansan
        Contact: jeanmarie.biansan@free.fr
    Web site: http://jeanmarie.biansan.free.fr/logiciel.html
    Reg_Lin_Mc is distribued under the terms of the
 GNU General Public License.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA}

unit unit_williamson_york;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,Unit1,Unit_genere_distribution,math,SpecFunX;

function regression_lineaire_williamson_york(x,y,ux,uy,correlation_xi_yi:extendedarray; nombre_points:integer;var pente,ordonnee_origine,u_pente,u_ordonnee_origine,
  covariance,coef_correlation:extended;
  tolerance: extended; nombre_maximal_boucles:integer; var vrai_x,vrai_y:extendedarray; var somme_carres_ecarts_ponderes:extended):boolean;

function regression_lineaire_ponderee_classique(x,y,uy:extendedarray; nombre_points:integer;var pente,ordonnee_origine,u_pente,u_ordonnee_origine,
  covariance,coef_correlation:extended; var vrai_x,vrai_y:extendedarray; var somme_carres_ecarts_ponderes:extended):boolean;

 function moindres_carres_classiques(x,y:extendedarray; nombre_points:integer;var pente,ordonnee_origine,u_pente,u_ordonnee_origine,
  covariance,coef_correlation:extended; var vrai_x,vrai_y:extendedarray; var ecart_type_residuel,coef_correlation_xy:extended;
  var residus_studentises:extendedarray):boolean;

function monte_carlo_williamson_york(liste_distributions_x,liste_distributions_y:array of distribution;  correlation_xi_yi:extendedarray;
  nombre_points_exp:integer;
  puissance_de_nombre_par_echantillon,nombre_par_echantillon,nombre_de_classes:integer;
  tolerance: extended; nombre_maximal_boucles:integer;
 var liste_echantillons_pente,liste_echantillons_ordonnee_origine,
        copie_liste_echantillons_pente,copie_liste_echantillons_ordonnee_origine:extendedarray;
  var estimateur_pente,ecart_type_pente,skewness_pente,kurtosis_pente,borne_inf_court_95_pente,borne_sup_court_95_pente,borne_inf_sym_95_pente,borne_sup_sym_95_pente,
     borne_inf_court_99_pente,borne_sup_court_99_pente,borne_inf_sym_99_pente,borne_sup_sym_99_pente,
     borne_inf_court_75_pente,borne_sup_court_75_pente,borne_inf_sym_75_pente,borne_sup_sym_75_pente:extended;
    var estimateur_ordonnee_origine,ecart_type_ordonnee_origine,skewness_ordonnee_origine,kurtosis_ordonnee_origine,borne_inf_court_95_ordonnee_origine,borne_sup_court_95_ordonnee_origine,borne_inf_sym_95_ordonnee_origine,borne_sup_sym_95_ordonnee_origine,
     borne_inf_court_99_ordonnee_origine,borne_sup_court_99_ordonnee_origine,borne_inf_sym_99_ordonnee_origine,borne_sup_sym_99_ordonnee_origine,
     borne_inf_court_75_ordonnee_origine,borne_sup_court_75_ordonnee_origine,borne_inf_sym_75_ordonnee_origine,borne_sup_sym_75_ordonnee_origine:extended;
  var covariance_pente_ordonnee,coeff_corelation_pente_ordonnee:extended;
  var  bornes_pente,bornes_ordonnee_origine:extendedarray;
     var effectifs:longintarray2d;   var densites:extendedarray2D;   var eff_max:longint; var densite_max:extended;
   var vrai_x,vrai_y:extendedarray):boolean;


function Calcule_Ecart_Type_MonteCarlo_York(const donnees:extendedarray; const moyenne:extended; const nombre:longint; var ecart_type:extended):boolean;


function Ellipse_Binormale(sigma1,sigma2,covariance:extended; var axe1_x,axe1_y,axe2_x,axe2_y,lambda1,lambda2:extended):boolean;
function Ellipse_Binormale_Confiance(sigma1,sigma2,covariance,pourcentage_confiance:extended; var axe1_x,axe1_y,axe2_x,axe2_y,demi_axe1,demi_axe2:extended):boolean;
function Ellipse_Bistudent_Confiance(sigma1,sigma2,covariance,pourcentage_confiance,degre_liberte:extended; var axe1_x,axe1_y,axe2_x,axe2_y,demi_axe1,demi_axe2:extended):boolean;


implementation

function moindres_carres_classiques(x,y:extendedarray; nombre_points:integer;var pente,ordonnee_origine,u_pente,u_ordonnee_origine,
  covariance,coef_correlation:extended; var vrai_x,vrai_y:extendedarray; var ecart_type_residuel,coef_correlation_xy:extended;
  var residus_studentises:extendedarray):boolean;
 var sxy,syy,xm,ym,sxx,ti,hi:extended;  i:integer;
begin
 xm:=0;
 for i:=1 to nombre_points do xm:=xm+x[i-1]; xm:=xm/nombre_points;

  ym:=0;
 for i:=1 to nombre_points do ym:=ym+y[i-1]; ym:=ym/nombre_points;

 sxx:=0;
 for i:=1 to nombre_points do sxx:=sxx+sqr(x[i-1]-xm);

 syy:=0;
 for i:=1 to nombre_points do syy:=syy+sqr(y[i-1]-ym);

 sxy:=0;
  for i:=1 to nombre_points do sxy:=sxy+(x[i-1]-xm)*(y[i-1]-ym);

  if (sxx=0) or (syy=0) then begin
    result:=false;
                  exit;
  end;
  pente:=sxy/sxx;
  ordonnee_origine:=ym-pente*xm;
      setlength(residus_studentises,nombre_points);
   setlength(vrai_x,nombre_points);
    setlength(vrai_y,nombre_points);
   for i:=1 to nombre_points do vrai_x[i-1]:=x[i-1];
    for i:=1 to nombre_points do vrai_y[i-1]:=pente*x[i-1]+ordonnee_origine;

   ecart_type_residuel:=0;
    for i:=1 to nombre_points do ecart_type_residuel:=ecart_type_residuel+sqr(y[i-1]-vrai_y[i-1]);

    ecart_type_residuel:=sqrt(ecart_type_residuel/(nombre_points-2));
    if ecart_type_residuel<>0  then  begin
    u_pente:=ecart_type_residuel/sqrt(sxx);
    u_ordonnee_origine:=ecart_type_residuel*sqrt(1/nombre_points+sqr(xm)/sxx);
    covariance:=-sqr(ecart_type_residuel)*xm/sxx;
    coef_correlation:=covariance/u_pente/u_ordonnee_origine;
    coef_correlation_xy:=sxy/sqrt(sxx)/sqrt(syy);
            for i:=1 to nombre_points do begin
      hi:=1/nombre_points+sqr(x[i-1]-xm)/sxx;
      ti:=(y[i-1]-vrai_y[i-1])/ecart_type_residuel/sqrt(1-hi);
             residus_studentises[i-1]:=ti*sqrt(abs((nombre_points-3)/(nombre_points-2-sqr(ti))));
             end; end else
             begin
              u_pente:=NAN;
               u_ordonnee_origine:=NAN;
                 covariance:=NAN;
                  coef_correlation:=NAN;
                  coef_correlation_xy:=NAN;
                    for i:=1 to nombre_points do residus_studentises[i-1]:=NAN;
              end;


    result:=true;
end;

function regression_lineaire_ponderee_classique(x,y,uy:extendedarray; nombre_points:integer;var pente,ordonnee_origine,u_pente,u_ordonnee_origine,
  covariance,coef_correlation:extended; var vrai_x,vrai_y:extendedarray; var somme_carres_ecarts_ponderes:extended):boolean;
var  s,sx,sy,sxx,sxy,delta:extended; i,j:integer;

 begin
 s:=0;
 for i:=1 to nombre_points do s:=s+1/sqr(uy[i-1]);
 sx:=0;
  for i:=1 to nombre_points do sx:=sx+x[i-1]/sqr(uy[i-1]);
 sy:=0;
  for i:=1 to nombre_points do sy:=sy+y[i-1]/sqr(uy[i-1]);
 sxx:=0;
  for i:=1 to nombre_points do sxx:=sxx+sqr(x[i-1])/sqr(uy[i-1]);
 sxy:=0;
  for i:=1 to nombre_points do sxy:=sxy+x[i-1]*y[i-1]/sqr(uy[i-1]);
   delta:=s*sxx-sqr(sx);
   if delta=0 then begin
   result:=false;
   exit;
   end;
   result:=true;
   pente:=(s*sxy-sx*sy)/delta;
   ordonnee_origine:=(sy*sxx-sxy*sx)/delta;
   u_pente:=sqrt(s/delta);
   u_ordonnee_origine:=sqrt(sxx/delta);
   covariance:=-sx/delta;
   coef_correlation:=covariance/u_pente/u_ordonnee_origine;
   setlength(vrai_x,nombre_points);
    setlength(vrai_y,nombre_points);

   for i:=1 to nombre_points do begin
   vrai_x[i-1]:=x[i-1];
   vrai_y[i-1]:=pente*x[i-1]+ordonnee_origine;
   end;
   somme_carres_ecarts_ponderes:=0;
   for i:=1 to nombre_points do
   somme_carres_ecarts_ponderes:=somme_carres_ecarts_ponderes+sqr((vrai_y[i-1]-y[i-1])/uy[i-1]);


 end;

function Ellipse_Binormale(sigma1,sigma2,covariance:extended; var axe1_x,axe1_y,axe2_x,axe2_y,lambda1,lambda2:extended):boolean;
var b,c,rho,alpha:extended;

begin
rho:=covariance/(sigma1*sigma2);

{lambda1:=0.5*(sqr(sigma1)+sqr(sigma2)+sqrt(sqr(sqr(sigma1)+sqr(sigma2))-4*sqr(sigma1)*sqr(sigma2)*(1-sqr(rho))));
lambda2:=0.5*(sqr(sigma1)+sqr(sigma2)-sqrt(sqr(sqr(sigma1)+sqr(sigma2))-4*sqr(sigma1)*sqr(sigma2)*(1-sqr(rho))));

if rho<>0 then begin
b:=(sqr(sigma2)-sqr(sigma1)+sqrt(sqr(sqr(sigma1)+sqr(sigma2))-4*sqr(sigma1)*sqr(sigma2)*(1-sqr(rho))))/(2*rho*sqrt(sqr(sigma1)*sqr(sigma2)));
axe1_x:=1/sqrt(1+sqr(b));
axe1_y:=b/sqrt(1+sqr(b));
c:=(sqr(sigma2)-sqr(sigma1)-sqrt(sqr(sqr(sigma1)+sqr(sigma2))-4*sqr(sigma1)*sqr(sigma2)*(1-sqr(rho))))/(2*rho*sqrt(sqr(sigma1)*sqr(sigma2)));
axe2_x:=1/sqrt(1+sqr(c));
axe2_y:=c/sqrt(1+sqr(c));
end else
begin
if sigma1>sigma2 then begin
axe1_x:=1;
axe1_y:=0;
axe2_x:=0;
axe2_y:=1;
end else
begin
 axe1_x:=0;
axe1_y:=1;
axe2_x:=1;
axe2_y:=0;

end; end;}
 if sqr(sigma1)-sqr(sigma2)<>0 then
alpha:=1/2*arctan(2*rho*sigma1*sigma2/(sqr(sigma1)-sqr(sigma2))) else
  alpha:=pi/4;
lambda1:=sqrt(sqr(sigma1*cos(alpha))+rho*sigma1*sigma2*sin(2*alpha)+sqr(sigma2*sin(alpha)));
lambda2:=sqrt(sqr(sigma1*sin(alpha))-rho*sigma1*sigma2*sin(2*alpha)+sqr(sigma2*cos(alpha)));
 axe1_x:=cos(alpha);
 axe1_y:=sin(alpha);
  axe2_x:=cos(alpha+pi/2);
 axe2_y:=sin(alpha+pi/2);
end;

function Ellipse_Binormale_Confiance(sigma1,sigma2,covariance,pourcentage_confiance:extended; var axe1_x,axe1_y,axe2_x,axe2_y,demi_axe1,demi_axe2:extended):boolean;
var lambda1,lambda2:extended;
 begin
 Ellipse_Binormale(sigma1,sigma2,covariance,axe1_x,axe1_y,axe2_x,axe2_y,lambda1,lambda2);
 demi_axe1:=lambda1*sqrt((-2*ln(1-pourcentage_confiance/100)));
 demi_axe2:=lambda2*sqrt((-2*ln(1-pourcentage_confiance/100)));
 end;


function Ellipse_Bistudent_Confiance(sigma1,sigma2,covariance,pourcentage_confiance,degre_liberte:extended; var axe1_x,axe1_y,axe2_x,axe2_y,demi_axe1,demi_axe2:extended):boolean;
var lambda1,lambda2,k:extended;
 begin
 Ellipse_Binormale(sigma1,sigma2,covariance,axe1_x,axe1_y,axe2_x,axe2_y,lambda1,lambda2);
 if  degre_liberte<1000 then
 k:=sqrt(-degre_liberte+exp(-2/degre_liberte*ln((2-pourcentage_confiance/100*degre_liberte*gammax(degre_liberte/2)/
 gammax(degre_liberte/2+1))/2/(power(degre_liberte,(degre_liberte/2)))))) else
  k:=sqrt(-2*ln(1-pourcentage_confiance/100));
 demi_axe1:=lambda1*k;
 demi_axe2:=lambda2*k;
 end;


function MyIsnan(x: float): boolean;
 {-Return true if x is a NaN}
begin
 with TExtRec(x) do begin
   MyIsnan := (xp and $7FFF=$7FFF) and ((hm<>longint($80000000)) or (lm<>0));
 end;
end;

function isnanorinfinite(x:float):boolean;
begin
result:=(myisnan(x) or isinfinite(x));
end;



function regression_lineaire_williamson_york(x,y,ux,uy,correlation_xi_yi:extendedarray; nombre_points:integer;var pente,ordonnee_origine,u_pente,u_ordonnee_origine,covariance,coef_correlation:extended;
  tolerance: extended; nombre_maximal_boucles:integer; var vrai_x,vrai_y:extendedarray; var somme_carres_ecarts_ponderes:extended):boolean;
var wi,ui,vi,betai,ux_carre,uy_carre,xi,yi,petit_ui:extendedarray;  i,boucle:integer;  x_barre,y_barre,beta_barre,petit_x_barre,petit_y_barre:extended;  m,new_m,b:extended;
  somme_x,somme_y,somme_xy,somme_xx,somme_w,somme_wbetav,somme_wbetau:extended;
begin
if nombre_points<=2 then begin
regression_lineaire_williamson_york:=false;
exit;
end;

setlength(wi,nombre_points);
setlength(ui,nombre_points);
setlength(petit_ui,nombre_points);
setlength(vi,nombre_points);
setlength(betai,nombre_points);
setlength(ux_carre,nombre_points);
setlength(uy_carre,nombre_points);
setlength( vrai_x,nombre_points);
setlength( vrai_y,nombre_points);
setlength(yi,nombre_points); setlength(xi,nombre_points);
for i:= 1 to nombre_points do ux_carre[i-1]:=sqr(ux[i-1]);
for i:= 1 to nombre_points do uy_carre[i-1]:=sqr(uy[i-1]);


{calcul de la pente et de l'ordonnee a l'origine par methode classique
pour initialiser la boucle}
somme_x:=0;  for i:= 1 to nombre_points do somme_x:=somme_x+x[i-1];
somme_y:=0;  for i:= 1 to nombre_points do somme_y:=somme_y+y[i-1];
somme_xy:=0;  for i:= 1 to nombre_points do somme_xy:=somme_xy+x[i-1]*y[i-1];
somme_xx:=0;  for i:= 1 to nombre_points do somme_xx:=somme_xx+sqr(x[i-1]);
m:=(nombre_points*somme_xy-somme_x*somme_y)/(nombre_points*somme_xx-sqr(somme_x));
b:=somme_y/nombre_points-m*somme_x/nombre_points;
new_m:=m;
{boucle de l'algorithme}
boucle:=0;
repeat
    m:=new_m;
    inc(boucle);
  for i:= 1 to nombre_points do wi[i-1]:=1/(uy_carre[i-1]+sqr(m)*ux_carre[i-1]-2*m*correlation_xi_yi[i-1]*ux[i-1]*uy[i-1]);
  somme_w:=0; for i:= 1 to nombre_points do somme_w:=somme_w+wi[i-1];
    x_barre:=0;   for i:= 1 to nombre_points do x_barre:=x_barre+wi[i-1]*x[i-1];
    x_barre:=x_barre/somme_w;
    y_barre:=0;   for i:= 1 to nombre_points do y_barre:=y_barre+wi[i-1]*y[i-1];
    y_barre:=y_barre/somme_w;
    for i:= 1 to nombre_points do ui[i-1]:=x[i-1]-x_barre;
    for i:= 1 to nombre_points do vi[i-1]:=y[i-1]-y_barre;
     for i:= 1 to nombre_points do betai[i-1]:=wi[i-1]*(ui[i-1]*uy_carre[i-1]+m*vi[i-1]*ux_carre[i-1]-(m*ui[i-1]+vi[i-1])*correlation_xi_yi[i-1]*ux[i-1]*uy[i-1]);
    somme_wbetau:=0;  for i:= 1 to nombre_points do  somme_wbetau:=somme_wbetau+wi[i-1]*betai[i-1]*ui[i-1];
    somme_wbetav:=0;  for i:= 1 to nombre_points do  somme_wbetav:=somme_wbetav+wi[i-1]*betai[i-1]*vi[i-1];
    new_m:=somme_wbetav/somme_wbetau;
    until (abs(m-new_m)<tolerance) or (boucle=nombre_maximal_boucles);


  if (boucle>=nombre_maximal_boucles) then begin
  regression_lineaire_williamson_york:=false;
exit;
  end;
  pente:=new_m;
  for i:= 1 to nombre_points do wi[i-1]:=1/(uy_carre[i-1]+sqr(pente)*ux_carre[i-1]-2*pente*correlation_xi_yi[i-1]*ux[i-1]*uy[i-1]);
  somme_w:=0; for i:= 1 to nombre_points do somme_w:=somme_w+wi[i-1];
    x_barre:=0;   for i:= 1 to nombre_points do x_barre:=x_barre+wi[i-1]*x[i-1];
    x_barre:=x_barre/somme_w;
    y_barre:=0;   for i:= 1 to nombre_points do y_barre:=y_barre+wi[i-1]*y[i-1];
    y_barre:=y_barre/somme_w;


  ordonnee_origine:=y_barre-pente*x_barre;

     for i:= 1 to nombre_points do betai[i-1]:=wi[i-1]*(ui[i-1]*uy_carre[i-1]+pente*vi[i-1]*ux_carre[i-1]-(pente*ui[i-1]+vi[i-1])*correlation_xi_yi[i-1]*ux[i-1]*uy[i-1]);
      for i:= 1 to nombre_points do vrai_x[i-1]:=x_barre+ betai[i-1];
    for i:= 1 to nombre_points do vrai_y[i-1]:=y_barre+ pente*betai[i-1];

    petit_x_barre:=0;
      for i:= 1 to nombre_points do petit_x_barre:=petit_x_barre+wi[i-1]*vrai_x[i-1];
      petit_x_barre:=petit_x_barre/somme_w;



   for i:= 1 to nombre_points do petit_ui[i-1]:=vrai_x[i-1]-petit_x_barre;


   beta_barre:=0;   for i:= 1 to nombre_points do beta_barre:=beta_barre+wi[i-1]*betai[i-1];
   beta_barre:=beta_barre/somme_w;

   u_pente:=0;  for i:= 1 to nombre_points do  u_pente:=u_pente+wi[i-1]*sqr(petit_ui[i-1]);
   u_pente:=1/sqrt(u_pente);

   u_ordonnee_origine:=sqrt(1/somme_w+sqr(petit_x_barre*u_pente));

   covariance:=-petit_x_barre*sqr(u_pente);
   coef_correlation:=-petit_x_barre*u_pente/u_ordonnee_origine;
    regression_lineaire_williamson_york:=true;
  somme_carres_ecarts_ponderes:=0;
 for i:= 1 to nombre_points do    somme_carres_ecarts_ponderes:= somme_carres_ecarts_ponderes+
 wi[i-1]*sqr(y[i-1]-pente*x[i-1]-ordonnee_origine);


end;

function monte_carlo_williamson_york(liste_distributions_x,liste_distributions_y:array of distribution;  correlation_xi_yi:extendedarray;
  nombre_points_exp:integer;
  puissance_de_nombre_par_echantillon,nombre_par_echantillon,nombre_de_classes:integer;
  tolerance: extended; nombre_maximal_boucles:integer;
 var liste_echantillons_pente,liste_echantillons_ordonnee_origine,
        copie_liste_echantillons_pente,copie_liste_echantillons_ordonnee_origine:extendedarray;
  var estimateur_pente,ecart_type_pente,skewness_pente,kurtosis_pente,borne_inf_court_95_pente,borne_sup_court_95_pente,borne_inf_sym_95_pente,borne_sup_sym_95_pente,
     borne_inf_court_99_pente,borne_sup_court_99_pente,borne_inf_sym_99_pente,borne_sup_sym_99_pente,
     borne_inf_court_75_pente,borne_sup_court_75_pente,borne_inf_sym_75_pente,borne_sup_sym_75_pente:extended;
    var estimateur_ordonnee_origine,ecart_type_ordonnee_origine,skewness_ordonnee_origine,kurtosis_ordonnee_origine,borne_inf_court_95_ordonnee_origine,borne_sup_court_95_ordonnee_origine,borne_inf_sym_95_ordonnee_origine,borne_sup_sym_95_ordonnee_origine,
     borne_inf_court_99_ordonnee_origine,borne_sup_court_99_ordonnee_origine,borne_inf_sym_99_ordonnee_origine,borne_sup_sym_99_ordonnee_origine,
     borne_inf_court_75_ordonnee_origine,borne_sup_court_75_ordonnee_origine,borne_inf_sym_75_ordonnee_origine,borne_sup_sym_75_ordonnee_origine:extended;
  var covariance_pente_ordonnee,coeff_corelation_pente_ordonnee:extended;
var  bornes_pente,bornes_ordonnee_origine:extendedarray;
  var effectifs:longintarray2d;   var densites:extendedarray2D; var eff_max:longint; var densite_max:extended;
        var vrai_x,vrai_y:extendedarray):boolean;




 var indice_point_a_traiter,i:integer;
   liste_echantillons_y,liste_echantillons_x:array of extendedarray;
   xx,yy,uuxx,uuyy:extendedarray;   uupp,uuoo,covcov,corcor:extended;
  temp_vrai_x,temp_vrai_y:extendedarray;
u_estimateur_pente,u_estimateur_ordonnee_origine:extended;
x_sur_droite,y_sur_droite:extendedarray;  mo1,ec1,sk1,ku1,mo2,ec2,sk2,ku2,ccc:extended;
  somme_carre_ecarts_ponderes:extended;
 begin
 setlength(uuxx,nombre_points_exp); setlength(uuyy,nombre_points_exp);
 for indice_point_a_traiter:=1 to  nombre_points_exp do begin
  uuxx[indice_point_a_traiter-1]:=liste_distributions_x[indice_point_a_traiter-1].incertitude_type;
  uuyy[indice_point_a_traiter-1]:=liste_distributions_y[indice_point_a_traiter-1].incertitude_type;
   end;
  setlength(xx,nombre_points_exp); setlength(yy,nombre_points_exp);
   for indice_point_a_traiter:=1 to  nombre_points_exp do begin
  xx[indice_point_a_traiter-1]:=liste_distributions_x[indice_point_a_traiter-1].moyenne;
  yy[indice_point_a_traiter-1]:=liste_distributions_y[indice_point_a_traiter-1].moyenne;
   end;

 regression_lineaire_williamson_york(xx,yy,uuxx,uuyy,correlation_xi_yi,nombre_points_exp,estimateur_pente,estimateur_ordonnee_origine,u_estimateur_pente,u_estimateur_ordonnee_origine,
  covcov,corcor,tolerance,nombre_maximal_boucles,vrai_x,vrai_y,somme_carre_ecarts_ponderes);


 setlength(liste_echantillons_x,nombre_points_exp);

    setlength(liste_echantillons_y,nombre_points_exp);


     for indice_point_a_traiter:=0 to  nombre_points_exp-1 do   if correlation_xi_yi[indice_point_a_traiter]=0 then
    case liste_distributions_x[indice_point_a_traiter].tyty    of
 d_normale:begin
  Genere_Normale(liste_echantillons_x[indice_point_a_traiter],nombre_par_echantillon,  vrai_x[indice_point_a_traiter],
 liste_distributions_x[indice_point_a_traiter].incertitude_type);

   end;
  d_student:begin
  Genere_Student(liste_echantillons_x[indice_point_a_traiter],nombre_par_echantillon,  vrai_x[indice_point_a_traiter],
 liste_distributions_x[indice_point_a_traiter].ecart_type_echantionnal, liste_distributions_x[indice_point_a_traiter].degres_de_liberte);

   end;
  d_rectangle:begin
  Genere_Rectangulaire(liste_echantillons_x[indice_point_a_traiter],nombre_par_echantillon,  vrai_x[indice_point_a_traiter],
 liste_distributions_x[indice_point_a_traiter].demi_etendue);

 end;
  d_triangle:begin
   Genere_Triangulaire(liste_echantillons_x[indice_point_a_traiter],nombre_par_echantillon,  vrai_x[indice_point_a_traiter],
 liste_distributions_x[indice_point_a_traiter].demi_etendue);

  end;
  d_trapeze:begin
  Genere_Trapeze(liste_echantillons_x[indice_point_a_traiter],nombre_par_echantillon,  vrai_x[indice_point_a_traiter],
 liste_distributions_x[indice_point_a_traiter].demi_etendue_bas,liste_distributions_x[indice_point_a_traiter].demi_etendue_haut);

  end;
  d_arcsin: begin
  Genere_Derivee_D_Arcsinus(liste_echantillons_x[indice_point_a_traiter],nombre_par_echantillon,  vrai_x[indice_point_a_traiter],
 liste_distributions_x[indice_point_a_traiter].demi_etendue);

  end;
  end;

      for indice_point_a_traiter:=0 to  nombre_points_exp-1 do   if correlation_xi_yi[indice_point_a_traiter]=0 then
    case liste_distributions_y[indice_point_a_traiter].tyty    of
 d_normale:begin
  Genere_Normale(liste_echantillons_y[indice_point_a_traiter],nombre_par_echantillon,  vrai_y[indice_point_a_traiter],
 liste_distributions_y[indice_point_a_traiter].incertitude_type);

   end;
  d_student:begin
  Genere_Student(liste_echantillons_y[indice_point_a_traiter],nombre_par_echantillon,  vrai_y[indice_point_a_traiter],
 liste_distributions_y[indice_point_a_traiter].ecart_type_echantionnal, liste_distributions_y[indice_point_a_traiter].degres_de_liberte);

   end;
  d_rectangle:begin
  Genere_Rectangulaire(liste_echantillons_y[indice_point_a_traiter],nombre_par_echantillon,  vrai_y[indice_point_a_traiter],
 liste_distributions_y[indice_point_a_traiter].demi_etendue);

 end;
  d_triangle:begin
   Genere_Triangulaire(liste_echantillons_y[indice_point_a_traiter],nombre_par_echantillon,  vrai_y[indice_point_a_traiter],
 liste_distributions_y[indice_point_a_traiter].demi_etendue);

  end;
  d_trapeze:begin
  Genere_Trapeze(liste_echantillons_y[indice_point_a_traiter],nombre_par_echantillon,  vrai_y[indice_point_a_traiter],
 liste_distributions_y[indice_point_a_traiter].demi_etendue_bas,liste_distributions_y[indice_point_a_traiter].demi_etendue_haut);

  end;
  d_arcsin: begin
  Genere_Derivee_D_Arcsinus(liste_echantillons_y[indice_point_a_traiter],nombre_par_echantillon,  vrai_y[indice_point_a_traiter],
 liste_distributions_y[indice_point_a_traiter].demi_etendue);

  end;
  end;


   for indice_point_a_traiter:=0 to  nombre_points_exp-1 do   if correlation_xi_yi[indice_point_a_traiter]<>0 then
  begin
  Genere_BiNormale(liste_echantillons_x[indice_point_a_traiter],liste_echantillons_y[indice_point_a_traiter],nombre_par_echantillon,
  vrai_x[indice_point_a_traiter],
 liste_distributions_x[indice_point_a_traiter].incertitude_type,
 vrai_y[indice_point_a_traiter],
 liste_distributions_y[indice_point_a_traiter].incertitude_type,
 correlation_xi_yi[indice_point_a_traiter]);

   Calcule_Moyenne_Et_Ecart_Type(liste_echantillons_x[indice_point_a_traiter],nombre_par_echantillon,mo1,ec1,sk1,ku1);
    Calcule_Moyenne_Et_Ecart_Type(liste_echantillons_y[indice_point_a_traiter],nombre_par_echantillon,mo2,ec2,sk2,ku2);
 Calcule_Covariance(liste_echantillons_x[indice_point_a_traiter],liste_echantillons_y[indice_point_a_traiter],nombre_par_echantillon,ccc);

 end;

 setlength(liste_echantillons_pente,nombre_par_echantillon);
 setlength(liste_echantillons_ordonnee_origine,nombre_par_echantillon);

 setlength(xx,nombre_points_exp); setlength(yy,nombre_points_exp);


  for i:=1 to nombre_par_echantillon do begin
  for indice_point_a_traiter:=1 to  nombre_points_exp do begin
  xx[indice_point_a_traiter-1]:=liste_echantillons_x[indice_point_a_traiter-1][i-1];
  yy[indice_point_a_traiter-1]:=liste_echantillons_y[indice_point_a_traiter-1][i-1];
   end;
  regression_lineaire_williamson_york(xx,yy,uuxx,uuyy,correlation_xi_yi,nombre_points_exp,liste_echantillons_pente[i-1],liste_echantillons_ordonnee_origine[i-1],
  uupp,uuoo,covcov,corcor,tolerance,nombre_maximal_boucles,temp_vrai_x,temp_vrai_y,somme_carre_ecarts_ponderes);
 end;
  Copie_Distribution(liste_echantillons_ordonnee_origine,copie_liste_echantillons_ordonnee_origine,nombre_par_echantillon);
     Copie_Distribution(liste_echantillons_pente,copie_liste_echantillons_pente,nombre_par_echantillon);

    Tri_Rapide(copie_liste_echantillons_ordonnee_origine,nombre_par_echantillon);
 Decale_Doublons(copie_liste_echantillons_ordonnee_origine,nombre_par_echantillon);
  Tri_Rapide(copie_liste_echantillons_pente,nombre_par_echantillon);
 Decale_Doublons(copie_liste_echantillons_pente,nombre_par_echantillon);


 Statistiques_Par_Classe_2D(liste_echantillons_pente,liste_echantillons_ordonnee_origine,nombre_par_echantillon,nombre_de_classes
 ,nombre_de_classes,bornes_pente,bornes_ordonnee_origine,effectifs,densites,eff_max,densite_max);

  Calcule_Moyenne_Et_Ecart_Type(liste_echantillons_ordonnee_origine,nombre_par_echantillon,estimateur_ordonnee_origine,ecart_type_ordonnee_origine,
  skewness_ordonnee_origine,kurtosis_ordonnee_origine);
 Calcule_Ecart_Type_MonteCarlo_York(liste_echantillons_ordonnee_origine,estimateur_ordonnee_origine,nombre_par_echantillon,ecart_type_ordonnee_origine);
 Intervalle_Recouvrement_Le_Plus_Court(0.95,copie_liste_echantillons_ordonnee_origine,nombre_par_echantillon,borne_inf_court_95_ordonnee_origine,borne_sup_court_95_ordonnee_origine);
Intervalle_Recouvrement_Symetrique(0.95,copie_liste_echantillons_ordonnee_origine,nombre_par_echantillon,borne_inf_sym_95_ordonnee_origine,borne_sup_sym_95_ordonnee_origine);
Intervalle_Recouvrement_Le_Plus_Court(0.99,copie_liste_echantillons_ordonnee_origine,nombre_par_echantillon,borne_inf_court_99_ordonnee_origine,borne_sup_court_99_ordonnee_origine);
Intervalle_Recouvrement_Symetrique(0.99,copie_liste_echantillons_ordonnee_origine,nombre_par_echantillon,borne_inf_sym_99_ordonnee_origine,borne_sup_sym_99_ordonnee_origine);
Intervalle_Recouvrement_Le_Plus_Court(0.75,copie_liste_echantillons_ordonnee_origine,nombre_par_echantillon,borne_inf_court_75_ordonnee_origine,borne_sup_court_75_ordonnee_origine);
Intervalle_Recouvrement_Symetrique(0.75,copie_liste_echantillons_ordonnee_origine,nombre_par_echantillon,borne_inf_sym_75_ordonnee_origine,borne_sup_sym_75_ordonnee_origine);

   Calcule_Moyenne_Et_Ecart_Type(liste_echantillons_pente,nombre_par_echantillon,estimateur_pente,ecart_type_pente,skewness_pente,kurtosis_pente);
Calcule_Ecart_Type_MonteCarlo_York(liste_echantillons_pente,estimateur_pente,nombre_par_echantillon,ecart_type_pente);


 Intervalle_Recouvrement_Le_Plus_Court(0.95,copie_liste_echantillons_pente,nombre_par_echantillon,borne_inf_court_95_pente,borne_sup_court_95_pente);
Intervalle_Recouvrement_Symetrique(0.95,copie_liste_echantillons_pente,nombre_par_echantillon,borne_inf_sym_95_pente,borne_sup_sym_95_pente);
Intervalle_Recouvrement_Le_Plus_Court(0.99,copie_liste_echantillons_pente,nombre_par_echantillon,borne_inf_court_99_pente,borne_sup_court_99_pente);
Intervalle_Recouvrement_Symetrique(0.99,copie_liste_echantillons_pente,nombre_par_echantillon,borne_inf_sym_99_pente,borne_sup_sym_99_pente);
Intervalle_Recouvrement_Le_Plus_Court(0.75,copie_liste_echantillons_pente,nombre_par_echantillon,borne_inf_court_75_pente,borne_sup_court_75_pente);
Intervalle_Recouvrement_Symetrique(0.75,copie_liste_echantillons_pente,nombre_par_echantillon,borne_inf_sym_75_pente,borne_sup_sym_75_pente);

 Calcule_Covariance(liste_echantillons_pente,liste_echantillons_ordonnee_origine,nombre_par_echantillon,covariance_pente_ordonnee);
 coeff_corelation_pente_ordonnee:=covariance_pente_ordonnee/ecart_type_pente/ecart_type_ordonnee_origine;

 end;

function Calcule_Ecart_Type_MonteCarlo_York(const donnees:extendedarray; const moyenne:extended; const nombre:longint; var ecart_type:extended):boolean;
   var est_multiple_de_10:boolean;  i,j,nb:longint;  do1,do2,do3,do4:extendedarray;
   begin

    Calcule_Ecart_Type_MonteCarlo_York:=true;
for i:=1 to nombre do
  if isnanorinfinite(donnees[i-1]) then begin
       ecart_type:=NAN;
   Calcule_Ecart_Type_MonteCarlo_York:=false;
    exit
    end;

  est_multiple_de_10:=((nombre mod 10)=0);
  Calcule_Ecart_Type_MonteCarlo_York:=est_multiple_de_10;
  if not(est_multiple_de_10) then exit;

  nb:=nombre;
     setlength(do1,nb);
     for i:=1 to nb do do1[i-1]:=donnees[i-1];
    setlength(do3,nb);
     for i:=1 to nb do do3[i-1]:=sqr(donnees[i-1]-moyenne);

     while ((nb mod 10)=0) do begin
          nb:=nb div 10;
    setlength(do2,nb);    setlength(do4,nb);
    for i:=1 to nb do
    begin
    do2[i-1]:=0;  do4[i-1]:=0;
    for j:=1 to 10 do do2[i-1]:=do2[i-1]+do1[(i-1)*10+j-1];
    for j:=1 to 10 do do4[i-1]:=do4[i-1]+do3[(i-1)*10+j-1];
    do2[i-1]:=do2[i-1]/10;   do4[i-1]:=do4[i-1]/10;
    end;
    setlength(do1,nb);
    for i:=1 to nb do do1[i-1]:=do2[i-1];
    setlength(do3,nb);
    for i:=1 to nb do do3[i-1]:=do4[i-1];
      end;

     ecart_type:=0;
    for i:=1 to nb do ecart_type:=ecart_type+do3[i-1];
    ecart_type:=ecart_type/nb;
    ecart_type:=sqrt(ecart_type);
    end;


end.

